Package: QRscore
Title: Quantile Rank Score
Version: 1.2.0
Date: 2025-03-28
Authors@R: c(
    person("Fanding", "Zhou", email = "zhoufd@berkeley.edu", role = c("cre","aut"),
    comment = c(ORCID = "0000-0003-1306-740X")),
    person("Alan", "Aw", email = "nalawanij@gmail.com", role = c("aut"), 
    comment = c(ORCID = "0000-0001-9455-7878")), 
    person("Dan", "Erdmann-Pham", email = "erdpham@stanford.edu", role = "aut"),
    person("Jonathan", "Fischer", email = "jfischer1@ufl.edu", role = "aut", 
    comment = c(ORCID = "0000-0002-1165-9930")),
    person("Xurui", "Chen", email = "xuruichen@berkeley.edu", role = "ctb")
    )
Description: In genomics, differential analysis enables the discovery of groups of genes implicating important biological processes such as cell differentiation and aging. Non-parametric tests of differential gene expression usually detect shifts in centrality (such as mean or median), and therefore suffer from diminished power against alternative hypotheses characterized by shifts in spread (such as variance). This package provides a flexible family of non-parametric two-sample tests and K-sample tests, which is based on theoretical work around non-parametric tests, spacing statistics and local asymptotic normality (Erdmann-Pham et al., 2022+ [arXiv:2008.06664v2]; Erdmann-Pham, 2023+ [arXiv:2209.14235v2]).  
License: GPL (>= 3)
Depends: R (>= 4.4.0)
Imports: MASS, pscl, arrangements, hitandrun, assertthat, dplyr,
        BiocParallel
Suggests: devtools, DESeq2, knitr, rmarkdown, testthat, BiocStyle
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-10-30 05:52:29 UTC; biocbuild
VignetteBuilder: BiocStyle
URL: https://github.com/songlab-cal/QRscore
BugReports: https://github.com/songlab-cal/QRscore/issues
biocViews: StatisticalMethod, DifferentialExpression, GeneExpression,
        StructuralGenomics, GeneTarget
git_url: https://git.bioconductor.org/packages/QRscore
git_branch: RELEASE_3_22
git_last_commit: 89dd601
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
Author: Fanding Zhou [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-1306-740X>),
  Alan Aw [aut] (ORCID: <https://orcid.org/0000-0001-9455-7878>),
  Dan Erdmann-Pham [aut],
  Jonathan Fischer [aut] (ORCID: <https://orcid.org/0000-0002-1165-9930>),
  Xurui Chen [ctb]
Maintainer: Fanding Zhou <zhoufd@berkeley.edu>

# QRscore

QRscore is an R package designed for analysis of differentially expressed genes 
(DEGs) and differentially dispersed genes (DDGs). The workflow is shown 
in the following figure.

![Workflow](vignettes/fig1.jpg)

## Installation

QRscore requires the following packages to run effectively:

```r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
if (!requireNamespace("DESeq2", quietly = TRUE)) {
    BiocManager::install("DESeq2")
}
```


You can install the **QRscore** package from 
[Bioconductor](https://bioconductor.org) with the following command:

```r
if (!requireNamespace("QRscore", quietly = TRUE)) {
    BiocManager::install("QRscore")
}
```

Alternatively, you can install the **QRscore** package from github:

```r
if (!requireNamespace("devtools", quietly = TRUE)) {
    install.packages("devtools")
}
devtools::install_github("Fanding-Zhou/QRscore")
```

## Loading QRscore

After installation, load QRscore and its dependencies:

```r
library(QRscore)
library(DESeq2)
```

## Usage

Here’s a brief example of how to use QRscore in your analysis pipeline:

1. **Preparing Data**: QRscore takes in RNA-seq count matrix and group labels 
as input and perform prefiltering and normalization.

```r
data("example_dataset_raw_3000_genes")

bulk_sparse_mat = example_dataset_raw_3000_genes$COUNTS
ages = example_dataset_raw_3000_genes$METADATA$AGE

## filter out low expressed genes
col_means <- colMeans(bulk_sparse_mat, na.rm = TRUE)
col_zeros <- colMeans(bulk_sparse_mat==0, na.rm = TRUE)
col_ids <- which(col_means>5&col_zeros<0.2) # The threshold can be modified

## normalization
bulk_df <- bulk_sparse_mat[,col_ids]
expr_mat <- t(bulk_df)
coldata <- data.frame(age = ages)
dds <- DESeqDataSetFromMatrix(countData = expr_mat,
                                colData = coldata,
                                design = ~ age)
dds <- estimateSizeFactors(dds)
est_size_factors = dds$sizeFactor
```

2. **Running Analysis**: Example code for setting up and performing the QRscore 
analysis.

```r
kept_samples <- coldata$age %in% c("40-49", "60-69")
expr_mat <- expr_mat[, kept_samples] # directly use raw counts
est_size_factors <- est_size_factors[kept_samples]
coldata <- coldata[kept_samples,]
results <- QRscoreGenetest(expr_mat, coldata, size_factors = est_size_factors, 
pairwise_test = TRUE, pairwise_logFC = TRUE, test_mean = TRUE, 
test_dispersion = TRUE, num_cores = 4, approx = "asymptotic")
```

3. **Interpreting Results**: QRscore outputs include differential expression 
and differential dispersion p-values, together with log Fold Change and 
log Variance Change. 


## License

GPL (>= 3)



## References

For more information and detailed usage, refer to the QRscore vignette, 
documentation and package help files.

#' @keywords internal
.prepare_gene_input <- function(expr_matrix) {
    expr_list <- split(
        t(expr_matrix),
        rep(seq_len(nrow(expr_matrix)),
            each = ncol(expr_matrix)
        )
    )
    gene_names <- rownames(expr_matrix)
    gene_names_list <- split(gene_names,
        f = seq_len(length(gene_names))
    )
    Map(function(x, y) list(x, y), expr_list, gene_names_list)
}

#' @keywords internal
.extract_and_format_results <- function(test_type, test_results,
                                        pval_name, rank = TRUE) {
    if (!is.null(test_results)) {
        test_results[[paste0(test_type, "_adj_p_value")]] <-
            p.adjust(test_results[[pval_name]], method = "BH")
        if (rank) {
            test_results <-
                test_results[order(test_results[[pval_name]]), ]
        }
        pvals <- c(pval_name, paste0(test_type, "_adj_p_value"))
        test_results <- test_results[, c(
            pvals,
            setdiff(names(test_results), pvals)
        )]
    }
    return(test_results)
}

# Updated .pairwise_tests to support size_factors
.pairwise_tests <- function(
    gene_vec, labels, unique_labels, test_mean, test_dispersion, pairwise_test, 
    pairwise_logFC, gene.name, mean_test_list, var_test_list, 
    size_factors = NULL, ...) {
    for (i in seq_len(length(unique_labels) - 1)) {
        for (j in (i + 1):length(unique_labels)) {
            idx_i <- labels == unique_labels[i]
            idx_j <- labels == unique_labels[j]
            x <- gene_vec[idx_i]
            y <- gene_vec[idx_j]
            sf_pair <- if (!is.null(size_factors)) 
              c(size_factors[idx_i], size_factors[idx_j]) else NULL
            lbl <- paste0(unique_labels[j], "_vs_", unique_labels[i])

            if (pairwise_test && test_mean) {
                mean_p <- QRscoreTest(
                    samples = c(x, y),
                    labels = rep(unique_labels[c(i, j)], c(length(x), length(y))),
                    measure = "mean",
                    gene.name = gene.name,
                    size_factors = sf_pair,
                    ...
                )
                mean_test_list[[paste0("Pairwise_Test_Mean_", lbl)]] <- mean_p
            }
            if (pairwise_test && test_dispersion) {
                var_p <- QRscoreTest(
                    samples = c(x, y),
                    labels = rep(unique_labels[c(i, j)], c(length(x), length(y))),
                    measure = "dispersion",
                    gene.name = gene.name,
                    size_factors = sf_pair,
                    ...
                )
                var_test_list[[paste0("Pairwise_Test_Var_", lbl)]] <- var_p
            }
            if (pairwise_logFC && test_mean) {
                logfc_mean <- if (!is.null(sf_pair)) {
                    log2(mean(y / size_factors[idx_j]) / 
                        mean(x / size_factors[idx_i]))
                } else {
                    log2(mean(y) / mean(x))
                }
                mean_test_list[[paste0("Log_FC_Mean_", lbl)]] <- logfc_mean
            }
            if (pairwise_logFC && test_dispersion) {
                logfc_var <- if (!is.null(sf_pair)) {
                    log2(var(y / size_factors[idx_j]) / 
                        var(x / size_factors[idx_i]))
                } else {
                    log2(var(y) / var(x))
                }
                var_test_list[[paste0("Log_FC_Var_", lbl)]] <- logfc_var
            }
        }
    }
    return(list(mean = mean_test_list, var = var_test_list))
}



#' @keywords internal
.add_test_result <- function(x, y, label1, label2,
                             gene_vec, gene.name, measure,
                             do_test, do_logfc,
                             test_list, suffix, size_factors = NULL,...) {
    if (do_test) {
        pval <- QRscoreTest(
            samples = c(x, y),
            labels = rep(
                c(label1, label2),
                c(length(x), length(y))
            ),
            measure = measure,
            gene.name = gene.name, size_factors = size_factors,...
        )
        test_list[[paste0("QRscore_", suffix, "_p_value")]] <- pval
    }

    if (do_logfc) {
        stat_fn <- if (measure == "mean") mean else var
        if (!is.null(size_factors)) {
            idx_x <- seq_len(length(x))
            idx_y <- (length(x)+1):(length(x)+length(y))
            x <- x / size_factors[idx_x]
            y <- y / size_factors[idx_y]
        }
        logfc <- log2(stat_fn(y) / stat_fn(x))
        test_list[[paste0(
            "Log_FC_", suffix, "_",
            label2, "_vs_", label1
        )]] <- logfc
    }
    return(test_list)
}

#' @keywords internal
.QRscore_one_gene_test <- function(gene_list, labels, size_factors = NULL,
                                   pairwise_test = TRUE, pairwise_logFC = TRUE, 
                                   test_mean = TRUE,
                                   test_dispersion = FALSE, ...) {
    gene_vec <- gene_list[[1]]; gene.name <- gene_list[[2]]
    unique_labels <- sort(unique(labels))
    mean_test_list <- list(); var_test_list <- list()
    if (length(unique_labels) == 2) {
        x <- gene_vec[labels == unique_labels[1]]
        y <- gene_vec[labels == unique_labels[2]]
        if (!is.null(size_factors)) {
            idx_x <- labels == unique_labels[1]
            idx_y <- labels == unique_labels[2]
            sf_combined <- c(size_factors[idx_x], size_factors[idx_y])
        } else {
            sf_combined <- NULL
        }
        
        if (test_mean) {
            mean_test_list <- .add_test_result(
                x, y, unique_labels[1], unique_labels[2], gene_vec, gene.name, 
                "mean", pairwise_test, pairwise_logFC, mean_test_list,"Mean",
                size_factors = sf_combined, ...
                )
        }
        if (test_dispersion) {
            var_test_list <- .add_test_result(
              x, y, unique_labels[1], unique_labels[2], gene_vec, gene.name, 
              "dispersion", pairwise_test, pairwise_logFC, var_test_list, 
              "Var", size_factors = sf_combined, ...)
        }
    } else if (length(unique_labels) > 2) {
        if (test_mean) {
            mean_test_list[["QRscore_Mean_p_value"]] <- QRscoreTest(
                samples = gene_vec, labels = labels, measure = "mean", 
                gene.name = gene.name, size_factors = size_factors,...)
        } 
        if (test_dispersion) {
            var_test_list[["QRscore_Var_p_value"]] <- QRscoreTest(
                samples = gene_vec, labels = labels, measure = "dispersion", 
                gene.name = gene.name,  size_factors = size_factors,...
            )
        }
        if (pairwise_test || pairwise_logFC) {
            out <- .pairwise_tests(
                gene_vec, labels, unique_labels, test_mean, 
                test_dispersion, pairwise_test, pairwise_logFC,
                gene.name, mean_test_list, var_test_list,  
                size_factors = size_factors,...
            )
            mean_test_list <- out$mean; var_test_list <- out$var
        }
    }
    mean_test_df <- if (length(mean_test_list) > 0) {
        as.data.frame(mean_test_list, check.names = FALSE) } else NULL
    var_test_df <- if (length(var_test_list) > 0) {
        as.data.frame(var_test_list, check.names = FALSE)} else NULL
    return(list(mean_test = mean_test_df, var_test = var_test_df))
}


#' Perform Differential Expression Analysis using QRscore
#'
#' This function performs differential expression analysis using the QRscore 
#' method.
#'
#' @param expr_matrix A prefiltered raw count matrix (gene \eqn{\times} 
#' sample).
#' @param labels A vector of labels corresponding to the samples.
#' @param size_factors A vector of size factors estimated from DESeq2
#' @param pairwise_test Logical, whether to perform pairwise test statistics 
#' for more than two groups.
#' @param pairwise_logFC Logical, whether to calculate pairwise log fold 
#' changes for mean and variance.
#' @param test_mean Logical, whether to test the mean.
#' @param test_dispersion Logical, whether to test the dispersion.
#' @param num_cores Integer, number of cores to use for parallel processing.
#' @param verbose Logical, whether to suppress all messages except warnings and 
#' errors.
#' @param rank Logical. If TRUE, returns a ranked list of DEGs or DDGs sorted 
#' by p-values.
#' @param seed Integer. Set seed in parallel computing.
#' @param ... Additional arguments passed to the `QRscoreTest` function.
#' @return A list with two data frames: `mean_test` and `var_test`.
#' @export
#'
#' @examples
#' data(example_dataset)
#' results <- QRscoreGenetest(
#'   expr_matrix = example_dataset$example_data1,
#'   labels = example_dataset$labels1,
#'   size_factors = example_dataset$size_factors1,
#'   pairwise_test = FALSE, pairwise_logFC = TRUE,
#'   test_mean = TRUE, test_dispersion = TRUE, num_cores = 2,
#'   approx = "asymptotic"
#' )
#' head(results$var_test)
#'
#' results2 <- QRscoreGenetest(
#'   expr_matrix = example_dataset$example_data2,
#'   labels = example_dataset$labels2,
#'   size_factors = example_dataset$size_factors2,
#'   pairwise_test = TRUE, pairwise_logFC = TRUE,
#'   test_mean = TRUE, test_dispersion = FALSE, num_cores = 2,
#'   approx = "asymptotic"
#' )
#' head(results2$mean_test)
QRscoreGenetest <- function(
    expr_matrix, labels, size_factors = NULL, pairwise_test = FALSE,
    pairwise_logFC = FALSE, test_mean = TRUE, test_dispersion = FALSE,
    num_cores = 1, verbose = FALSE, rank = TRUE, seed = 1, ...) {
    bpparam <- if (num_cores > 1 && 
                   BiocParallel::multicoreWorkers() > 1) {
        BiocParallel::MulticoreParam(workers = num_cores, 
                                     RNGseed = seed)
    } else {
        BiocParallel::SerialParam(RNGseed = seed)
    }
    if (!is.null(size_factors)) {
        if (any(size_factors <= 0)) stop("All size factors must be > 0.")
    }

    combined_list <- .prepare_gene_input(expr_matrix)

    run_test <- function() {
        BiocParallel::bplapply(
            combined_list, .QRscore_one_gene_test,
            labels = labels,
            size_factors = size_factors,
            pairwise_test = pairwise_test,
            pairwise_logFC = pairwise_logFC,
            test_mean = test_mean,
            test_dispersion = test_dispersion,
            BPPARAM = bpparam, ...
        )
    }

    results_list <- if (!verbose) suppressMessages(run_test()) else run_test()

    mean_test_results <- do.call(
      rbind, lapply(results_list, function(x) x$mean_test))
    var_test_results  <- do.call(
      rbind, lapply(results_list, function(x) x$var_test))

    gene_names <- rownames(expr_matrix)
    if (!is.null(mean_test_results)) {
        rownames(mean_test_results) <- gene_names[seq_len(nrow(mean_test_results))]
    }
    if (!is.null(var_test_results)) {
        rownames(var_test_results) <- gene_names[seq_len(nrow(var_test_results))]
    }

    mean_test_results <- .extract_and_format_results(
        "QRscore_Mean", mean_test_results, "QRscore_Mean_p_value", rank)
    var_test_results <- .extract_and_format_results(
        "QRscore_Var", var_test_results, "QRscore_Var_p_value", rank)

    return(list(mean_test = mean_test_results, 
                var_test = var_test_results))
}

### Test QRscoreGenetest

test_that("QRscoreGenetest runs without error on simple input", {
    set.seed(1)
    data <- matrix(rnbinom(2000, mu = 20, size = 2), nrow = 10)
    rownames(data) <- paste0("gene", seq_len(10))
    labels <- rep(c("A", "B"), each = 100)
    result <- QRscoreGenetest(data, labels, test_mean = TRUE, test_dispersion = TRUE, pairwise_test = TRUE, pairwise_logFC = TRUE)
    expect_type(result, "list")
    expect_true(all(c("mean_test", "var_test") %in% names(result)))
    expect_s3_class(result$mean_test, "data.frame")
    expect_s3_class(result$var_test, "data.frame")
})


test_that("QRscoreGenetest output rownames set is the same as input gene names
          set", {
    set.seed(1)
    data <- matrix(rnbinom(2000, mu = 20, size = 2), nrow = 10)
    rownames(data) <- paste0("gene", seq_len(10))
    labels <- rep(c("A", "B"), each = 100)
    result <- QRscoreGenetest(data, labels, pairwise_test = TRUE)
    expect_true(setequal(rownames(result$mean_test), rownames(data)))
})

test_that("QRscoreGenetest get pairwise columns appear when requested", {
    set.seed(2)
    data <- matrix(rnbinom(1500, mu = 20, size = 2), nrow = 5)
    rownames(data) <- paste0("g", seq_len(5))
    labels <- rep(c("X", "Y", "Z"), each = 100)

    result <- QRscoreGenetest(data, labels,
        pairwise_test = TRUE,
        pairwise_logFC = TRUE
    )

    expect_true(any(grepl("Pairwise_Test", colnames(result$mean_test))))
    expect_true(any(grepl("Log_FC_Mean", colnames(result$mean_test))))
})


test_that("QRscoreTest performs one-sample test correctly", {
    set.seed(1)
    x <- abs(rnorm(10))
    w <- rep(1, 10)
    pval <- QRscoreTest(
        samples = x, p = 2, wList = w,
        alternative = "two.sided", approx = "resample"
    )
    expect_true(is.numeric(pval))
    expect_true(pval >= 0 && pval <= 1)
})

test_that("QRscoreTest performs two-sample test with weights", {
    set.seed(1)
    group1 <- rnorm(50)
    group2 <- rnorm(50, mean = 1)
    data <- c(group1, group2)
    labels <- rep(c("A", "B"), each = 50)
    wList <- c(50:0)
    pval <- QRscoreTest(
        samples = data, labels = labels, p = 1, wList = wList,
        alternative = "two.sided", approx = "resample"
    )
    expect_true(is.numeric(pval))
    expect_true(pval >= 0 && pval <= 1)
})

test_that("QRscoreTest performs two-sample test using NB weights", {
    set.seed(1)
    group1 <- rzinbinom(100, size = 2, mu = 20, pi = 0)
    group2 <- rzinbinom(100, size = 2, mu = 30, pi = 0)
    data <- c(group1, group2)
    labels <- rep(c("A", "B"), each = 100)
    pval <- QRscoreTest(
        samples = data, labels = labels, approx = "asymptotic",
        zero_inflation = FALSE, measure = "mean"
    )
    expect_true(is.numeric(pval))
    expect_true(pval >= 0 && pval <= 1)
})

test_that("QRscoreTest performs multi-sample test with NB model", {
    set.seed(1)
    g1 <- rnbinom(100, size = 1, mu = 20)
    g2 <- rnbinom(100, size = 2, mu = 20)
    g3 <- rnbinom(100, size = 3, mu = 20)
    data <- c(g1, g2, g3)
    labels <- rep(c("G1", "G2", "G3"), each = 100)
    pval <- QRscoreTest(
        samples = data, labels = labels, approx = "asymptotic",
        zero_inflation = FALSE, measure = "dispersion"
    )
    expect_true(is.numeric(pval))
    expect_true(pval >= 0 && pval <= 1)
})

#' @keywords internal
.dzinbinom <- function(x, mu, theta, size, pi, log = FALSE) {
    if (any(pi < 0) | any(pi > 1)) {
        warning("'pi' must be in [0, 1]")
    }
    if (!missing(theta) & !missing(size)) {
        stop("only 'theta' or 'size' may be specified")
    }
    if (!missing(size)) {
        theta <- size
    }
    rval <- log(1 - pi) + dnbinom(x, mu = mu, size = theta, log = TRUE)
    if (any(x0 <- (x == 0L))) {
        rval[x0] <- log(exp(rval) + pi)[x0]
    }
    if (log) {
        return(rval)
    } else {
        return(exp(rval))
    }
}

#' @keywords internal
.qzinbinom <- function(p, mu, theta, size, pi,
                       lower.tail = TRUE, log.p = FALSE) {
    if (any(pi < 0) | any(pi > 1)) {
        warning("'pi' must be in [0, 1]")
    }
    if (!missing(theta) & !missing(size)) {
        stop("only 'theta' or 'size' may be specified")
    }
    if (!missing(size)) {
        theta <- size
    }
    if (log.p) {
        p <- exp(p)
    }
    if (!lower.tail) {
        p <- 1 - p
    }
    p <- pmax(0, (p - pi) / (1 - pi))
    rval <- qnbinom(p,
        mu = mu, size = theta,
        lower.tail = TRUE, log.p = FALSE
    )
    return(rval)
}

#' @keywords internal
.get_gaussion_asymptotics_moments <- function(Snk, n, k, wList, p) {
    # internal function for .qrscore_flex_two_sample (QRscore_Flex)
    if (p == 1) {
        m1 <- sum(wList) / k
        m2 <- ((k / n + 1) / (k^2 * (k + 1))) *
            sum(wList * ((k * diag(k) - outer(
                rep(1, k),
                rep(1, k)
            )) %*% wList))
    } else {
        m1 <- ((2 + k / n - 1 / n) / ((k + 1) * k)) * sum(wList)
        w2 <- sum(wList^2)
        coef1 <- (k - 1) * (k / n + 1) * (2 + k / n - 1 / n) *
            (12 - 6 / n + k * (k / n + 10 - 5 / n)) /
            (k^2 * (1 + k)^2 * (2 + k) * (3 + k))
        offdiag <- sum(outer(wList, wList)) - w2
        coef2 <- (k / n + 1) * (6 / n^2 + k * (3 + k * (k - 2)) /
            n^2 - 24 / n + 8 * (k - 1) * k / n +
            8 * (3 + 2 * k)) /
            (k^2 * (1 + k)^2 * (2 + k) * (3 + k))
        m2 <- w2 * coef1 - offdiag * coef2
    }
    return(list(mean = m1, var = m2))
}

#' @keywords internal
.compute_exact_pval <- function(t, exact_ts, alternative) {
    # internal function for getCompositionPValue()
    if (alternative == "two.sided") {
        message(date(), ": Computing exact two-sided p-value")
        upper_tail <- mean(exact_ts >= t)
        cdf_at_t <- mean(exact_ts <= t)
        return(2 * min(cdf_at_t, upper_tail))
    } else if (alternative == "greater") {
        message(
            date(),
            ": Computing exact one-sided p-value with alternative `greater`"
        )
        return(mean(exact_ts >= t))
    } else {
        message(
            date(),
            ": Computing exact one-sided p-value with alternative `less`"
        )
        return(mean(exact_ts <= t))
    }
}

#' @keywords internal
.compute_resample_pval <- function(t, resampled_ts, alternative, type) {
    # internal function for getCompositionPValue()
    cdf_at_t <- mean(resampled_ts < t)
    cdf_at_t_upp_tail <- 1 - mean(c(resampled_ts, t) >= t)
    cdf_at_t_low_tail <- mean(c(resampled_ts, t) <= t)

    if (alternative == "two.sided") {
        message(date(), ": Computing two-sided p-value")
        if (type == "unbiased") {
            return(2 * min(cdf_at_t, 1 - cdf_at_t))
        } else if (type == "valid") {
            return(2 * min(cdf_at_t_low_tail, 1 - cdf_at_t_upp_tail))
        } else {
            return(c(
                unbiased = 2 * min(cdf_at_t, 1 - cdf_at_t),
                valid = 2 * min(cdf_at_t_low_tail, 1 - cdf_at_t_upp_tail)
            ))
        }
    } else if (alternative == "greater") {
        message(
            date(),
            ": Computing one-sided p-value with alternative `greater`"
        )
        if (type == "unbiased") {
            return(1 - cdf_at_t)
        } else if (type == "valid") {
            return(1 - cdf_at_t_upp_tail)
        } else {
            return(c(
                unbiased = 1 - cdf_at_t,
                valid = 1 - cdf_at_t_upp_tail
            ))
        }
    } else {
        message(date(), ": Computing one-sided
                p-value with alternative `less`")
        if (type == "unbiased") {
            return(cdf_at_t)
        } else if (type == "valid") {
            return(cdf_at_t_low_tail)
        } else {
            return(c(
                unbiased = cdf_at_t,
                valid = cdf_at_t_low_tail
            ))
        }
    }
}


#' @keywords internal
.Gamma_derivative_disp <- function(theta, x, beta) {
    # internal function for computeweight_disp
    x4 <- gamma(theta * beta)
    x1 <- beta * digamma(theta * beta + x)
    x2 <- (beta * (x4 * digamma(theta * beta))) / x4
    return(x1 - x2)
}

#' @keywords internal
.z_function_disp <- function(x, beta, mu, pi) {
    # internal function for computeweight_disp
    if (x == 0) {
        num <- (1 - pi) * (beta / (beta + mu))^(beta + 1) *
            ((beta + mu) * log(beta / (beta + mu)) + mu)
        denom <- (1 - pi) * (beta / (beta + mu))^beta + pi
        return(num / denom)
    } else {
        return((.Gamma_derivative_disp(1, x, beta) +
            beta * (mu - x) / (beta + mu) +
            beta * log(beta / (beta + mu))) * (1 - pi))
    }
}



.estimate_nb_parameters <- function(counts, offset = NULL) {
    # internal function for QRscore_ZINB
    message(date(), ": Estimating NB parameters.")

    if (is.null(offset)) {
        fit <- MASS::glm.nb(counts ~ 1)
    } else {
        df <- data.frame(y = counts, offset_var = offset)
        fit <- tryCatch(
            MASS::glm.nb(y ~ offset(offset_var), data = df),
            error = function(e) {
                message("Offset model failed, using normalized counts.")
                df2 <- data.frame(y = round(counts/exp(offset)))
                MASS::glm.nb(y ~ 1, data = df2)
        })
    }

    list(beta = min(fit$theta, 100), mu = exp(coef(fit)["(Intercept)"]), pi = 0)
}

.estimate_zinb_parameters <- function(counts, offset = NULL) {
    # internal function for QRscore_ZINB
    message(date(), ": Estimating ZINB parameters.")
    if (!is.null(offset)) {
        df <- data.frame(y = counts, offset_var = offset)
        fitZINB <- tryCatch(
            pscl::zeroinfl(y ~ offset(offset_var) | 1, data = df, dist = "negbin"), 
            error = function(e) {
                message("Offset model failed, using normalized counts.")
                df2 <- data.frame(y = round(counts/exp(offset)))
                pscl::zeroinfl(y ~ 1 | 1, data = df2, dist = "negbin")
        })
    } else {
        df <- data.frame(y = counts)
        fitZINB <- pscl::zeroinfl(y ~ 1 | 1, data = df, dist = "negbin")
    }
    beta <- min(fitZINB$theta, 100)
    mu <- exp(fitZINB$coef$count[1])
    zcoef <- fitZINB$coef$zero[1]
    pi <- exp(zcoef)/(1 + exp(zcoef))
    return(list(fitZINB = fitZINB, beta = beta, mu = mu, pi = pi))
}



.fit_and_validate_zinb <- function(combined, offset = NULL, gene.name, pi_threshold, LR.test) {
    # internal function for QRscore_ZINB
    zinb <- .estimate_zinb_parameters(combined, offset = offset)
    if (LR.test) {
        message(date(), ": Applying likelihood ratio test.")
        if (!is.null(offset)) {
            df <- data.frame(y = combined, offset_var = offset)
            fitNB <- MASS::glm.nb(y ~ offset(offset_var), data = df)
        } else {
            fitNB <- MASS::glm.nb(combined ~ 1)
        }

        lrt_p <- as.numeric(pchisq(2 * (logLik(zinb$fitZINB) - logLik(fitNB)), 
                                   df = 1, lower.tail = FALSE))
        if (lrt_p >= 0.05) {
            return(.estimate_nb_parameters(combined, offset = offset))
        }
    }

    if (zinb$pi > pi_threshold) {
        msg <- if (is.null(gene.name)) {
            sprintf("The estimated probability of zeros is > %.2f.", pi_threshold)
        } else {
            sprintf("The estimated probability of zeros for gene %s is > %.2f.", 
                    gene.name, pi_threshold)
        }
        warning(sprintf("%s Returning NA.", msg))
        return(NULL)
    }

    return(zinb)
}




#' @keywords internal
.generateBMatrix <- function(d) {
    # internal function for QRscore_ZINB_nSmaples
    vectors <- matrix(0, nrow = d - 1, ncol = d)
    for (k in seq_len(d - 1)) {
        vector <- rep(0, d)
        vector[seq_len(k)] <- 1
        vector[k + 1] <- -k
        norm_factor <- sqrt(sum(vector^2))
        vectors[k, ] <- vector / norm_factor
    }
    return(t(vectors))
}

#' @keywords internal
.generateAAmatrix <- function(props) {
    # internal function for QRscore_ZINB_nSmaples
    m <- length(props)
    mat <- matrix(NA, m, m)
    for (i in seq_len(m)) {
        for (j in seq_len(m)) {
            mat[i, j] <- if (i == j) {
                1 - props[i]
            } else {
                -sqrt(props[i] * props[j])
            }
        }
    }
    return(mat)
}

#' @keywords internal
.computeSscores <- function(sample_list, weights, N_all) {
    # internal function for QRscore_ZINB_nSmaples
    scores <- numeric(length(sample_list))
    for (i in seq_along(sample_list)) {
        x <- sample_list[[i]]
        y <- unlist(sample_list[-i], use.names = FALSE)
        idx <- rank_x(x, y)
        scores[i] <- sum(weights[idx]) / sqrt(N_all)
    }
    return(scores)
}

#' @keywords internal
.get_H_new <- function(H_w, B_matrix, AA_matrix, gene.name) {
    # internal function for QRscore_ZINB_nSmaples
    H_modifier <- t(B_matrix) %*% AA_matrix %*% B_matrix
    H_modifier <- (H_modifier + t(H_modifier)) / 2
    H_new <- H_w * H_modifier
    if (any(is.na(H_new)) || any(is.infinite(H_new))) {
        msg <- "Covariance matrix contains NA or Inf values"
        if (!is.null(gene.name)) {
            msg <- sprintf("%s for gene %s", msg, gene.name)
        }
        warning(sprintf("%s, returning NA.", msg))
        return(NULL)
    }
    return(H_new)
}

#' @keywords internal
.get_H_inv <- function(H_new, gene.name) {
    # internal function for QRscore_ZINB_nSmaples
    if (isSymmetric(H_new) && all(eigen(H_new)$values > 0)) {
        return(chol2inv(chol(H_new)))
    }
    tryCatch(
        {
            solve(H_new)
        },
        error = function(e) {
            msg <- "Covariance matrix is not invertible"
            if (!is.null(gene.name)) {
                msg <- sprintf("%s for gene %s", msg, gene.name)
            }
            warning(sprintf("%s, returning NA.", msg))
            return(NA)
        }
    )
}

#' Generate random samples from a zero-inflated negative binomial distribution
#'
#' @param n Integer. Number of samples to generate.
#' @param mu Numeric. Mean of the negative binomial distribution.
#' @param theta Numeric. Dispersion parameter (size) of the negative binomial
#' distribution.
#' @param size Numeric. Alternative name for the dispersion parameter
#' (used interchangeably with `theta`).
#' @param pi Numeric. Zero-inflation probability; must be in the range
#' \eqn{[0,1]}.
#' @return A vector of random samples from a Zero-Inflated Negative Binomial
#' (ZINB) distribution.
#' @examples
#' set.seed(1)
#' rzinbinom(n = 5, mu = 10, theta = 5, pi = 0.2)
#' @export
rzinbinom <- function(n, mu, theta, size, pi) {
    if (any(pi < 0) | any(pi > 1)) {
        warning("'pi' must be in [0, 1]")
    }
    if (!missing(theta) &
        !missing(size)) {
        stop("only 'theta' or 'size' may be specified")
    }
    if (!missing(size)) {
        theta <- size
    }
    rval <- stats::rnbinom(n, mu = mu, size = theta)
    rval[stats::runif(n) < pi] <- 0
    return(rval)
}







#' Approximate p-value by Resampling Integer Compositions
#'
#' Given the value of the test statistic \eqn{t}, the sample sizes \eqn{n} and
#' \eqn{k},power exponent \eqn{p} and vector of weights that together determine
#' the test statistic (by default \eqn{n\geqslant k}), as well as the
#' user-specified resampling number (by default this is \eqn{5000}),
#' performs resampling from the collection of integer compositions
#' to approximate the p-value of the observed test statistic.
#'
#' For \eqn{n} and \eqn{k} small enough (\eqn{n\leqslant 40, k\leqslant 10}),
#' computes exact p-value by computing the test statistic across all
#' \eqn{k}-compositions of \eqn{n} under the uniform distribution.
#'
#' The function returns a two-sided p-value by default, which is more
#' conservative. Users can choose other p-values corresponding to different
#' alternatives; see documentation on `alternative`. Note that the
#' interpretation of the choice of `alternative` depends on the choice of
#' weight vector. For example, a weight vector that is a quadratic kernel will
#' upweight the extreme components of the weight vector. For this choice,
#' setting `alternative` to be `greater` translates into an alternative
#' hypothesis of a bigger spread in the larger sample
#' (the one with sample size \eqn{n}).
#'
#' Dependencies: arrangements::compositions
#' @param t Value of test statistic \eqn{||S_{n,k}(D)/n||_{p,\boldsymbol{w}}^p}
#' computed from data \eqn{D}
#' @param n Sample size of \eqn{y}
#' @param k Sample size of \eqn{x}
#' @param p Power exponent of test statistic
#' @param wList Weight vector
#' @param alternative Character string that should be one of "`two.sided`"
#' (default), "`greater`" or "`less`"
#' @param type If using resampling approximation, either an unbiased estimate
#' of ("`unbiased`", default), or valid, but biased estimate of, ("`valid`")
#' p-value (see Hemerik and Goeman, 2018), or both ("`both`").
#' Default is "`unbiased`".
#' @param resamp_number Number of compositions of \eqn{n} to draw
#' (default is 5000)
#' @return p-value (scalar)
#' @examples
#'
#' getCompositionPValue(
#'     t = 0.5, n = 50, k = 11, p = 1, wList = (10:0) / 10,
#'     alternative = "two.sided", type = "unbiased", resamp_number = 5000
#' )
#'
#' @export
getCompositionPValue <- function(t, n, k, p, wList,
                                 alternative, type, resamp_number) {
    if (n <= 40 & k <= 10) {
        message(
            date(),
            ": n and k are small enough, computing exact p-value..."
        )
        exact_ts <- ((arrangements::compositions(n = n, k = k) / n)^p %*%
            wList) %>% as.vector()
        return(.compute_exact_pval(t, exact_ts, alternative))
    } else {
        resampled_ts <- ((
            arrangements::compositions(
                n = n, k = k,
                nsample = resamp_number
            ) / n
        )^p %*% wList) %>% as.vector()
        return(
            .compute_resample_pval(t, resampled_ts, alternative, type)
        )
    }
}

#' Retrieve indices of \eqn{x_i}'s after merging \eqn{\boldsymbol{x}} and
#' \eqn{\boldsymbol{y}} in ascending order.
#'
#' Given data consisting of either a single sample
#' \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)},
#' or two samples \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)} and
#' \eqn{\boldsymbol{y}=(y_1,\ldots,y_n)},
#' this function obtains the indices of \eqn{x_i}'s after merging
#' \eqn{\boldsymbol{x}} and \eqn{\boldsymbol{y}} in ascending order.
#'
#' Dependencies: None
#' @param x First sample
#' @param y Second sample
#' @param ties.break Whether to break the ties when ordering `x` and `y`.
#' Default is `'TRUE'`.
#' @return Ranks of \eqn{x_i}'s after merging `x` and `y` in ascending order
#' @examples
#'
#' set.seed(1)
#' rank_x(x = abs(rnorm(10)))
#' rank_x(x = abs(rnorm(10)), y = abs(rnorm(100)))
#' rank_x(
#'     x = rnbinom(10, size = 5, prob = 0.3),
#'     y = rnbinom(20, size = 2, prob = 0.3), ties.break = TRUE
#' )
#' @export
#'
rank_x <- function(x, y = NULL, ties.break = TRUE) {
    k <- length(x)
    n <- length(y)
    if (ties.break) {
        x_y_sorted <- sort(c(x, y))
        differences <- diff(x_y_sorted)
        # Find the minimum difference that greater than 0
        minimal_gap <- min(differences[differences > 0])
        # Perturb x and y to avoid ties
        x <- runif(k, 0, minimal_gap / 2) + x
        y <- runif(n, 0, minimal_gap / 2) + y
    }
    x_ordered <- sort(x)
    x <- sort(x)
    x_rank <- c()
    # Obtain the rank of x_i after merging x and y in ascending order
    for (i in seq_len(k)) {
        x_rank[i] <- sum(c(x, y) < x_ordered[i]) + 1
    }
    return(x_rank)
}

#' Compute weights for mean shift analysis
#'
#' Given the value of the estimated parameters for zero-inflated negative
#' binomial distribution (\eqn{\beta}, \eqn{\mu}, \eqn{\pi}),the sample sizes
#' \eqn{n} and \eqn{k} (by default \eqn{n\geqslant k}), this function computes
#' weights that target changes in the mean parameter of the zero-inflated
#' negative binomial model.
#'
#' The function generates a vector of weights and an estimated variance that
#' are used to construct test statistics. The weight vector is computed by
#' considering how each potential count value from the combined distribution
#' contributes to the expected shift in mean, considering both inflated and
#' uninflated components.
#'
#' @param beta Dispersion parameter of the negative binomial component. Must be
#' strictly positive.
#' @param mu Mean of the uninflated negative binomial distribution. Should be
#' non-negative.
#' @param pi Probability of zeros due to zero inflation.
#' @param n Sample size of \eqn{y}
#' @param k Sample size of \eqn{x}
#' @return A list containing a weight vector (`$weight`) and
#' estimated variance (`$var`) useful for constructing test statistics.
#' @examples
#'
#' computeweight_mean(beta = 5, mu = 40, pi = 0.1, n = 100, k = 60)
#'
#' @export
computeweight_mean <- function(beta, mu, pi, n, k) {
    p <- beta / (beta + mu)
    Gdict <- .qzinbinom(seq_len(n + k) / (n + k + 1),
        size = beta,
        mu = mu,
        pi = pi
    )
    z_function <- function(x) {
        if (x == 0) {
            mu * (pi - 1) * (beta / (beta + mu))^(beta + 1) /
                (pi + (1 - pi) * (beta / (beta + mu))^beta)
        } else {
            (beta * x / (beta + mu) - beta * mu / (beta + mu)) * (1 - pi)
        }
    }
    term1 <- beta * mu / (beta + mu)
    term2 <- (beta / (beta + mu))^beta
    term3 <- (1 - pi)^2
    term4 <- beta^2 * term3 * (beta / (beta + mu))^(2 * beta + 2)
    term5 <- pi + (1 - pi) * term2

    H_value <- (term1 - term1^2 * term2) * term3 + term4 / term5

    test_var <- H_value # Put alpha*(1-alpha)* in QRscore_ZINB
    results <- list()
    zvals <- vapply(Gdict, z_function, numeric(1))
    results$weight <- zvals - mean(zvals)
    if (any(is.na(test_var)) ||
        any(is.infinite(test_var)) || all(test_var == 0)) {
        results$var <- var(zvals)
        message("Using weight dictionary to calculate variance.")
    } else {
        results$var <- test_var
    }
    results$var <- test_var
    return(results)
}




#' Compute weights for dispersion shift analysis
#'
#' Given the value of the estimated parameters for zero-inflated negative
#' binomial distribution (\eqn{\beta}, \eqn{\mu}, \eqn{\pi}), the sample sizes
#' \eqn{n} and \eqn{k} (by default \eqn{n\geqslant k}), this function computes
#' weights that target on changes of the dispersion parameter in zero-inflated
#' negative binomial model.
#'
#' The function returns a list containing a weight vector and estimated
#' variance for constructing test statistics.
#'
#' @param beta Target for number of successful trials, or dispersion parameter.
#' Must be strictly positive.
#' @param mu Non-negative mean of the uninflated negative binomial
#' distribution.
#' @param pi Zero inflation probability for structural zeros.
#' @param n Sample size of \eqn{y}
#' @param k Sample size of \eqn{x}
#' @param tail Distribution tail trimmed for numerically calculate expectation.
#' Default is \eqn{10^{-4}}
#' @param bigN Sampling numbers for numerically calculate expectation, this
#' will only be applied when mean parameter is extremely large.
#' Default is \eqn{10^6}
#' @return A list containing a weight vector (`$weight`) and estimated variance
#' (`$var`) useful for constructing test statistics.
#' @examples
#'
#' set.seed(1)
#' computeweight_disp(
#'     beta = 5, mu = 40, pi = 0.1, n = 100, k = 60,
#'     tail = 10^(-4), bigN = 10^6
#' )
#'
#' @export
#'
computeweight_disp <- function(beta, mu, pi, n, k,
                               tail = 10^(-4), bigN = 10^6) {
    p <- beta / (beta + mu)
    Gdict <- .qzinbinom(seq_len(n + k) / (n + k + 1),
        size = beta, mu = mu, pi = pi
    )

    if (mu > 10^4) {
        ## This is for extremely large mus to avoid large number issue
        data <- rzinbinom(bigN, size = beta, mu = mu, pi = pi)
        x_prob <- table(data) / bigN
        x_values <- as.numeric(names(x_prob))
    } else {
        ## For smaller mu's, calculate the expectation without sampling
        tail.q <- .qzinbinom(1 - tail, size = beta, mu = mu, pi = pi)
        x_prob <- .dzinbinom(0:tail.q, size = beta, mu = mu, pi = pi)
        x_values <- 0:tail.q
    }

    z_x_values <- vapply(x_values, function(x) {
        .z_function_disp(x, beta, mu, pi)
    }, numeric(1))

    E_z <- sum(z_x_values * x_prob)
    H_value <- sum((z_x_values - E_z)^2 * x_prob)
    test_var <- H_value

    zvals <- vapply(Gdict, function(x) {
        .z_function_disp(x, beta, mu, pi)
    }, numeric(1))

    results <- list()
    # Adjust the weights to mean 0.
    results$weight <- zvals - mean(zvals)
    assertthat::assert_that(sum(is.na(results$weight)) == 0,
        msg = "Weight cannot be calculated.
                          Check if estimated dispersion parameter beta is
                          less than 100."
    )

    if (any(is.na(test_var)) ||
        any(is.infinite(test_var)) || all(test_var == 0)) {
        results$var <- var(zvals)
        message("Using weight dictionary to calculate variance.")
    } else {
        results$var <- test_var
    }
    return(results)
}

# Test dzinbinom function
test_that("dzinbinom handles invalid 'pi' values", {
    expect_warning(.dzinbinom(x = 1, mu = 10, theta = 5, pi = -0.1))
    expect_warning(.dzinbinom(x = 1, mu = 10, theta = 5, pi = 1.1))
})

test_that("dzinbinom returns expected probabilities", {
    x_values <- 0:5
    expected_prob <- log(0.8) + dnbinom(x_values, mu = 3, size = 2, log = TRUE)
    expected_prob[1] <- log(exp(expected_prob[1]) + 0.2)
    calculated_prob <- .dzinbinom(
        x = x_values, mu = 3, theta = 2, pi = 0.2,
        log = TRUE
    )
    expect_true(all.equal(calculated_prob, expected_prob))
})


# Test qzinbinom function
test_that("qzinbinom handles invalid 'pi' values", {
    expect_warning(.qzinbinom(p = 0.5, mu = 10, theta = 5, pi = -0.1))
    expect_warning(.qzinbinom(p = 0.5, mu = 10, theta = 5, pi = 1.1))
})

test_that("qzinbinom returns correct quantiles", {
    expect_equal(
        .qzinbinom(p = 0.5, mu = 10, theta = 5, pi = 0),
        qnbinom(0.5, mu = 10, size = 5)
    )
})

# Test rzinbinom function
test_that("rzinbinom handles invalid 'pi' values", {
    expect_warning(rzinbinom(n = 10, mu = 10, theta = 5, pi = -0.1))
    expect_warning(rzinbinom(n = 10, mu = 10, theta = 5, pi = 1.1))
})

test_that("rzinbinom generates correct number of samples", {
    set.seed(1)
    samples <- rzinbinom(n = 100, mu = 10, theta = 5, pi = 0.2)
    expect_equal(length(samples), 100)
    expect_true(sum(samples == 0) > 0) # Check for zero inflation
})

# Test getCompositionPValue function
test_that("getCompositionPValue computes correct exact p-values for small n and
          k", {
    expect_true(getCompositionPValue(
        t = 0.5, n = 30, k = 5, p = 1,
        wList = rep(1, 5),
        alternative = "two.sided"
    ) >= 0)
})

# Test rank_x function
test_that("rank_x returns correct indices with tie-breaking", {
    set.seed(1)
    x <- rnorm(5)
    y <- rnorm(5)

    computed_ranks <- rank_x(x, y)
    expect_true(all(computed_ranks >= 1 & computed_ranks <= length(c(x, y))))
    expect_equal(length(unique(computed_ranks)), length(computed_ranks))
})


# Test computeweight_mean function
test_that("computeweight_mean computes weights correctly and contains no NAs", {
    results <- computeweight_mean(beta = 2, mu = 10, pi = 0.1, n = 50, k = 25)
    expect_true(is.list(results))
    expect_true("weight" %in% names(results))
    expect_true("var" %in% names(results))
    expect_true(all(!is.na(results$weight)), "No NAs in weight vector")
    expect_true(!is.na(results$var), "Variance is not NA")
})

# Test computeweight_disp function
test_that("computeweight_disp computes weights correctly and contains no NAs", {
    results <- computeweight_disp(beta = 2, mu = 10, pi = 0.1, n = 50, k = 25)
    expect_true(is.list(results))
    expect_true("weight" %in% names(results))
    expect_true("var" %in% names(results))
    expect_true(all(!is.na(results$weight)), "No NAs in weight vector")
    expect_true(!is.na(results$var), "Variance is not NA")
})

#' @keywords internal
.qrscore_flex_one_sample <- function(x, k, p, wList, alternative,
                                type, resamp_number) {
      # internal function for QRscore_Flex
    assertthat::assert_that(!any(x < 0))
    Sk <- x / sum(x)
    t <- sum(Sk^p * wList)
    message(date(), ": The test statistic for the data is ", t)
    message(date(), ": Resampling on simplex with ", resamp_number)
    res <- simplex.sample(n = k, N = resamp_number)$samples
    resampled_ts <- as.vector((res)^p %*% wList)
    cdf_t <- mean(resampled_ts < t)
    cdf_upp <- 1 - mean(c(resampled_ts, t) >= t)
    cdf_low <- mean(c(resampled_ts, t) <= t)
      
    if (alternative == "two.sided") {
        message(date(), ": Computing two-sided p-value")
        if (type == "unbiased") return(2 * min(cdf_t, 1 - cdf_t))
        if (type == "valid") return(2 * min(cdf_low, 1 - cdf_upp))
        return(setNames(c(2 * min(cdf_t, 1 - cdf_t),
                          2 * min(cdf_low, 1 - cdf_upp)),
                        c("unbiased", "valid")))
    }
  
    message(date(), ": Computing one-sided p-value with alternative = ",
            alternative)
    if (alternative == "greater") {
        if (type == "unbiased") return(1 - cdf_t)
        if (type == "valid") return(1 - cdf_upp)
        return(setNames(c(1 - cdf_t, 1 - cdf_upp),
                        c("unbiased", "valid")))
    }
    if (type == "unbiased") return(cdf_t)
    if (type == "valid") return(cdf_low)
    return(setNames(c(cdf_t, cdf_low), c("unbiased", "valid")))
}

#' @keywords internal
.qrscore_flex_two_sample <- function(x, y, k, p, wList, alternative,
                                approx, type, resamp_number) {
    # internal function for QRscore_Flex
    x_ordered <- sort(x)
    x_ordered <- c(-Inf, x_ordered, Inf)
    n <- length(y)
    
    Snk <- vapply(seq_len(k), function(i) {
        sum(y >= x_ordered[i] & y < x_ordered[i + 1])
    }, numeric(1))
    
    t <- if (approx == "resample" & !(n >= 100 & k >= 50)) {
        message(date(), ": Adjusting n and k for resampling")
        sum(((Snk + 1) / (n + k))^p * wList)
    } else {
        sum((Snk / n)^p * wList)
    }
  
    message(date(), ": The test statistic for the data is ", t)
    assertthat::assert_that(k / n >= 1e-3)
    
    if (approx == "asymptotic" | (n >= 100 & k >= 50)) {
        if (!(n >= 100 & k >= 50)) {
            warning("Sample sizes may be too small...")
        }
        message(date(), ": Applying Gaussian asymptotics...")
        moments <- .get_gaussion_asymptotics_moments(Snk, n, k, wList, p)
        z <- (t - moments$mean) / sqrt(moments$var)
        if (alternative == "two.sided") return(2 * min(pnorm(z), pnorm(-z)))
        if (alternative == "greater") return(pnorm(-z))
        return(pnorm(z))
    } else {
        message(date(), ": Using resampling approach with ", resamp_number)
        return(getCompositionPValue(
            t = t, n = n + k, k = k, p = p, wList = wList,
            alternative = alternative, type = type,
            resamp_number = resamp_number
        ))
    }
}



#' @keywords internal
.run_qrscore_one_sample <- function(samples, p, wList, alternative,
                               approx, type, n_mom, resamp_number) {
    # internal function for QRscoreTest
    message(date(), ": Performing a one-sample test.")
    assertthat::assert_that(!is.null(p),
        msg = "Exponent p must be provided."
    )
    assertthat::assert_that(!is.null(wList),
        msg = "wList must be provided."
    )
    assertthat::assert_that(length(samples) == length(wList),
        msg = "wList and sample lengths must match."
    )
    assertthat::assert_that(
        p > 0 &&
            abs(p - round(p)) < .Machine$double.eps^0.5,
        msg = "Only integer p supported."
    )
    assertthat::assert_that(approx == "resample",
        msg = "Only 'resample' supported."
    )

    QRscore_Flex(
        samples, NULL, p, wList, alternative,
        approx, type, n_mom, resamp_number
    )
}

#' @keywords internal

.run_qrscore_two_sample <- function(
    sample_list, unique_labels, alternative, approx, resamp_number,
    zero_inflation, LR.test, pi_threshold, gene.name, measure, p, wList,
    type, n_mom, use_base_r,size_factor_list) {
  
    x <- sample_list[[1]]
    y <- sample_list[[2]]
    
    x_label <- unique_labels[1]
    y_label <- unique_labels[2]
    if (length(x) > length(y)) {
        tmp <- x; x <- y; y <- tmp
        tmp <- x_label; x_label <- y_label; y_label <- tmp
    }
    if(!is.null(size_factor_list)){
        sf_x <- size_factor_list[[1]]
        sf_y <- size_factor_list[[2]]
        if (length(x) > length(y)) {
            tmp <- sf_x; sf_x <- sf_y; sf_y <- tmp
        }
        size_factors <- c(sf_x, sf_y)
    } else {
        size_factors <- NULL
    }
    message(date(), ": Performing a two-sample test. '", x_label,
            "' is x and '", y_label, "' is y.")
    if (is.null(wList) || is.null(p)) {
        message(date(), ": Use ZINB or NB model to estimate weights.")
        return(QRscore_ZINB(x, y, size_factors, zero_inflation, LR.test,
                            approx, alternative, resamp_number, pi_threshold,
                            gene.name, measure))
    }
    assertthat::assert_that(length(x) + 1 == length(wList),
                            msg = "wList must have length = length(x) + 1.")
    assertthat::assert_that(p > 0 &&
                              abs(p - round(p)) < .Machine$double.eps^0.5,
                            msg = "Only integer p supported.")
    assertthat::assert_that(approx == "resample",
                            msg = "Only 'resample' supported.")
    is_mann_whitney <- identical(wList, c(length(x):0)) && p == 1
    if (is_mann_whitney && use_base_r) {
        message(date(), ": Using base R Mann-Whitney test...")
        return(wilcox.test(x, y, alternative = alternative,
                           correct = FALSE)$p.value)
    }
    message(date(), ": Using QRscore_Flex with given weights.")
    if(!is.null(size_factor_list)){
        return(QRscore_Flex(x/sf_x, y/sf_y , p, wList, 
                            alternative, approx, type, n_mom, resamp_number))
    } else {
        return(QRscore_Flex(x, y , p, wList, 
                            alternative, approx, type, n_mom, resamp_number))
    }
}



#' Flexible Non-Parametric One- and Two-Sample Tests (Native R version)
#'
#' Given data consisting of either a single sample
#' \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)},
#' or two samples \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)} and
#' \eqn{\boldsymbol{y}=(y_1,\ldots,y_n)},
#' this function uses summary statistics computed on weighted linear
#' combinations of powers of the spacing statistics
#' \eqn{S_k} (former) or \eqn{S_{n,k}} (latter).
#'
#' More precisely, this function does the following:
#'
#' For a single sample \eqn{x}, the function tests for uniformity of its
#' entries. When \eqn{p=2} and a particular choice of \eqn{\boldsymbol{w}} is
#' specified, we recover Greenwood's test.
#'
#' For two samples, the function tests the null of \eqn{\boldsymbol{x}} and
#' \eqn{\boldsymbol{y}} being drawn from the same distribution
#' (i.e., stochastic equality), against flexible alternatives that correspond
#' to specific choices of the test statistic parameters, \eqn{\boldsymbol{w}}
#' (weight vector) and \eqn{p} (power). These parameters not only determine the
#' test statistic \eqn{||S_k||_{p,\boldsymbol{w}}^p=\sum_{j=1}^k w_iS_{k}[j]^p}
#' (analogously defined for \eqn{||S_{n,k}||_{p,\boldsymbol{w}}^p}), but also
#' encode alternative hypotheses ranging from different populational means
#' (i.e., \eqn{\mu_x \neq \mu_y}), different populational spreads
#' (i.e., \eqn{\sigma^2_x \neq \sigma^2_y}), etc.
#'
#' Additional tuning parameters include:
#' (1) choice of p-value computation (one- or two-sided);
#' (2) approximation method
#' (3) number of moments accompanying the approximation chosen if using
#' moment-based approximation (recommended 200, typically at least 100); and
#' (4) in case of two samples, whether the user prefers to use exact discrete
#' moments (more accurate but slower) or to use continuous approximations of the
#' discrete moments (less accurate but faster).
#'
#' Currently, only resampling and Gaussian asymptotics are supported.
#' Both are efficient and well-calibrated. For \eqn{n\geqslant 100} and
#' \eqn{k\geqslant 50} such that \eqn{\frac{k}{n}\geqslant 0.001},
#' function automatically uses Gaussian approximation to the null.
#'
#' Dependencies: functions in `utils.R`
#' @param x First sample
#' @param y Second sample
#' @param p Exponent value in defining test statistic (must be integer)
#' @param wList Vector of weights. It should have length equal to \eqn{x} when
#' \eqn{y} is `NULL`, and one more than the length of \eqn{x} when \eqn{y} is
#' not `NULL`
#' @param alternative How p-value should be computed; i.e., a character
#' specifying the alternative hypothesis, must be one of "`two.sided`",
#' "`greater`" or "`less`"
#' @param approx Which approximation method to use (choose "`resample`",
#' "`asymptotic`")
#' @param type If using resampling approximation, either an unbiased estimate of
#' ("`unbiased`", default), or valid, but biased estimate of, ("`valid`")
#' p-value (see Hemerik and Goeman, 2018), or both ("`both`").
#' Default is "`unbiased`".
#' @param n_mom The number of moments to accompany the approximation
#' (recommended 200, if not at least 100)
#' @param resamp_number Number of \eqn{k}-compositions of \eqn{n} or simplex
#' vectors in \eqn{[0,1]^k}  to draw
#' @return Returns the p-value.
#' @export
#' @examples
#'
#' set.seed(1)
#' # One-sample examples
#' QRscore_Flex(
#'     x = abs(rnorm(10)), p = 2, wList = rep(1, 10),
#'     alternative = "two.sided", approx = "resample"
#' )
#'
#' # Two-sample examples
#' QRscore_Flex(
#'     x = abs(rnorm(30)), y = abs(rnorm(100)), p = 2,
#'     wList = rep(1, 31), alternative = "two.sided",
#'     approx = "resample", resamp_number = 5000
#' )
#'
#' QRscore_Flex(
#'     x = abs(rnorm(100)), y = abs(rnorm(100)), p = 1,
#'     wList = 0:100, alternative = "two.sided",
#'     approx = "asymptotic"
#' )
#' @export
QRscore_Flex <- function(x, y = NULL, p = 1, wList,
                         alternative = "two.sided",
                         approx = "resample",
                         type = "unbiased",
                         n_mom = NULL,
                         resamp_number = 5000) {
    k <- if (!is.null(y)) length(x) + 1 else length(x)
    if (!is.null(y)) assertthat::assert_that(length(wList) == k)
    assertthat::assert_that(p %in% c(1, 2))
    assertthat::assert_that(approx %in% c("resample", "asymptotic"))
    wList <- wList / max(wList)
    message(date(), ": Normalizing weight vector...")

    if (!is.null(y)) {
        return(.qrscore_flex_two_sample(
            x, y, k, p, wList, alternative,
            approx, type, resamp_number
        ))
    } else {
        return(.qrscore_flex_one_sample(
            x, k, p, wList, alternative,
            type, resamp_number
        ))
    }
}



#' Non-Parametric Two-Sample Tests Designed for Testing Differences in Mean or
#' Dispersion Parameters in (Zero-Inflated) Negative Binomial Distributions.
#'
#' This function evaluates the null hypothesis that two samples,
#' \eqn{\boldsymbol{x}} and \eqn{\boldsymbol{y}}, are drawn from the same
#' distribution, specifically designed for NB or ZINB models. It is particularly
#' effective in detecting shifts in either the mean or the dispersion
#' parameters.
#'
#' The function automatically computes optimal weights for the chosen model and
#' derives a p-value based on the selected test statistic and approximation
#' method.
#'
#' Additional tuning parameters include: (1) whether to use a likelihood ratio
#' test to determine which model (NB or ZINB) to fit, (2) the approximation
#' method (default is resampling, with asymptotic estimation for large 
#' samples),(3) choice of p-value computation (one- or two-sided), 
#' (4) threshold for estimated proportion of zeros in ZINB model 
#' (returns NA if exceeded).
#'
#' Dependencies: pscl::zeroinfl, MASS::glm.nb, and auxiliary functions from
#' `auxiliary.R`
#' @param x First sample
#' @param y Second sample
#' @param size_factors Optional vector of size factors for weight estimation.
#'  If provided, log-transformed size factors are used as offsets in 
#'  NB/ZINB model fitting.
#' @param zero_inflation If TRUE, automatically chooses between ZINB and NB
#' models based on the data; if FALSE, applies NB model estimation.
#' @param LR.test Whether to use a likelihood ratio test to determine which
#' model (NB or ZINB) to fit
#' @param approx Which approximation method to use (default `resample`)
#' @param alternative How p-value should be computed; must be one of
#' "`two.sided`", "`greater`" or "`less`".
#' @param resamp_num Number of \eqn{k}-compositions of \eqn{n} or simplex
#' vectors in \eqn{[0,1]^k} to draw
#' @param pi_threshold Threshold for estimated proportion of zeros in ZINB model
#' @param gene.name Optional, name of the gene if applicable, used for
#' customized messages.
#' @param measure Specifies whether to test for shifts in "`mean`" or
#' "`dispersion`".
#' @param p_value If TRUE, returns a p-value, else returns test statistics and
#' weights.
#' @return p-value or test statistics depending on `p_value` parameter.
#' @examples
#'
#' set.seed(1)
#' # Two-sample example comparing mean shifts
#' QRscore_ZINB(
#'     x = rzinbinom(100, size = 2, mu = 20, pi = 0),
#'     y = rzinbinom(100, size = 2, mu = 30, pi = 0),
#'     zero_inflation = FALSE, LR.test = FALSE, alternative = "greater",
#'     approx = "asymptotic", measure = "mean"
#' )
#'
#' # Two-sample example comparing dispersion shifts
#' QRscore_ZINB(
#'     x = rzinbinom(100, size = 2, mu = 20, pi = 0.1),
#'     y = rzinbinom(100, size = 1, mu = 20, pi = 0.1),
#'     zero_inflation = TRUE, LR.test = TRUE, alternative = "two.sided",
#'     approx = "asymptotic", measure = "dispersion"
#' )
#'
#' # Two-sample example with significant zero inflation and variance shift
#' QRscore_ZINB(
#'     x = rzinbinom(30, size = 4, mu = 20, pi = 0.1),
#'     y = rzinbinom(30, size = 1, mu = 20, pi = 0.3),
#'     zero_inflation = TRUE, LR.test = FALSE, alternative = "two.sided",
#'     approx = "resample", resamp_num = 50000, measure = "dispersion"
#' )
#' # Two-sample example with size factors, zero inflation, and dispersion shift
#' sf_x <- runif(100, 0.5, 1.5)
#' sf_y <- runif(100, 0.5, 1.5)
#' QRscore_ZINB(
#'     x = rzinbinom(100, size = 4, mu = sf_x * 25, pi = 0.1),
#'     y = rzinbinom(100, size = 1,   mu = sf_y * 25, pi = 0.1),
#'     size_factors = c(sf_x, sf_y),
#'     zero_inflation = TRUE, LR.test = TRUE, alternative = "two.sided",
#'     approx = "resample", resamp_num = 20000, measure = "dispersion"
#' )
#' @export
#'
#'
QRscore_ZINB <- function(x, y, size_factors = NULL,
                         zero_inflation = TRUE, LR.test = FALSE,
                         approx = "resample", alternative = "two.sided",
                         resamp_num = 20000, pi_threshold = 0.95,
                         gene.name = NULL, measure = "mean", p_value = TRUE) {
    if (sum(round(x) != x) > 0 | sum(round(y) != y) > 0) {
        warning("Input values are not integers. Round input.")
        x <- round(x); y <- round(y)
    }
    assertthat::assert_that(!is.null(y), msg = "y should not be NULL.")
    assertthat::assert_that(all(x >= 0) & all(y >= 0),
                            msg = "Input contains negative values.")

    n <- length(y); k <- length(x); alpha <- k / (n + k)
    combined <- c(x, y)

    if (!is.null(size_factors)) {
        if (length(size_factors) != length(combined)) {
            stop("Length of size_factors must match length(x) + length(y).")
        }
        offset_combined <- log(size_factors)
        x_norm <- x / size_factors[seq_len(k)]
        y_norm <- y / size_factors[(k + 1):(k + n)]
    } else {
        offset_combined <- NULL; x_norm <- x; y_norm <- y
    }

    computeweight <- ifelse(
        measure == "dispersion", computeweight_disp, computeweight_mean
    )

    if (sum(combined == 0) == 0 || !zero_inflation) {
        est <- .estimate_nb_parameters(combined, offset = offset_combined)
    } else {
        est <- .fit_and_validate_zinb(combined, offset = offset_combined,
                                      gene.name = gene.name,
                                      pi_threshold = pi_threshold,
                                      LR.test = LR.test)
        if (is.null(est)) return(NA)
    }

    results <- computeweight(est$beta, est$mu, est$pi, n, k)
    if (!p_value) return(results)

    weights <- results$weight
    est_var <- alpha * (1 - alpha) * results$var
    zscore <- mean(weights[rank_x(x_norm, y_norm)])

    if (approx == "asymptotic" | (n >= 100 & k >= 50)) {
        zscore <- k / sqrt(n + k) * zscore
        p.value <- switch(
            alternative,
            "two.sided" = 2 * pnorm(abs(zscore), sd = sqrt(est_var), lower.tail = FALSE),
            "greater" = pnorm(zscore, sd = sqrt(est_var), lower.tail = FALSE),
            pnorm(zscore, sd = sqrt(est_var)))
    } else {
        if (n < 10 && k < 10) {
            message(date(), ": Using exact enumeration")
            comb_mat <- arrangements::combinations(n + k, k)
            exact_ts <- apply(comb_mat, 1, function(idx) mean(weights[idx]))
            p.exact <- mean(exact_ts < zscore)
            p.value <- switch(alternative,
                              "two.sided" = 2 * min(p.exact, 1 - p.exact),
                              "greater" = 1 - p.exact,
                              p.exact)
            if (p.value == 0) p.value <- 1 / nrow(comb_mat)
        } else {
            message(date(), ": Using resampling with ", resamp_num)
            null_zscore <- replicate(
                resamp_num, mean(weights[sample(seq_len(n + k), k)]))
            p.permute <- mean(null_zscore < zscore)
            p.value <- switch(alternative,
                              "two.sided" = 2 * min(p.permute, 1 - p.permute),
                              "greater" = 1 - p.permute,
                              p.permute)
        }
    }
    return(p.value)
}


#' Multi-Sample Nonparametric Test for Mean or Dispersion Differences in
#' (Zero-Inflated) Negative Binomial Distributions.
#'
#' This function conducts statistical tests across multiple samples to evaluate
#' the null hypothesis that all groups are drawn from the same distribution. It
#' is optimized for data modeled by Negative Binomial (NB) or Zero-Inflated
#' Negative Binomial (ZINB) distributions and is capable of detecting shifts in
#' mean or dispersion parameters. The function can handle any number of groups
#' and automatically computes optimal weights for the specified measure (mean or
#' dispersion).
#'
#' The computation involves constructing a B matrix that transforms
#' group-specific scores into a space where independence among groups is
#' maximized. It then uses these transformed scores to calculate a test
#' statistic, which follows a chi-square distribution under the null 
#' hypothesis.
#'
#' Additional tuning parameters allow customization of the model fitting and
#' statistical testing, including:
#' - Selection between NB and ZINB models based on presence of zero inflation.
#' - Choice of approximation method for computing p-values - 'asymptotic' is
#'   recommended.
#' - Decision criteria for statistical tests (one-sided or two-sided).
#' - Threshold for the estimated proportion of zeros beyond which results are
#'   considered unreliable.
#'
#' Dependencies: Requires `pscl::zeroinfl` for zero-inflated models,
#' `MASS::glm.nb` for NB models, and other auxiliary functions as needed.
#'
#' @param samples Vector of all sample measurements.
#' @param labels Group labels for each sample.
#' @param size_factors Optional vector of size factors for weight estimation.
#'  If provided, log-transformed size factors are used as offsets in 
#'  NB/ZINB model fitting.
#' @param zero_inflation Boolean, if TRUE, the function chooses between ZINB and
#'   NB models based on data; if FALSE, only NB model is applied.
#' @param LR.test Boolean, if TRUE, performs a likelihood ratio test to select
#'   between NB and ZINB models.
#' @param approx The method used for p-value approximation; "resample"
#'   (default) or "asymptotic".
#' @param resamp_num The number of resampling iterations used if `approx` is
#'   "resample".
#' @param pi_threshold Threshold for proportion of zeros at which to return NA,
#'   indicating unreliable results due to excessive zero inflation.
#' @param gene.name Optional, name of the gene if applicable, enhancing the
#'   relevance of output in genetic studies.
#' @param measure Specifies whether the test focuses on "mean" or "dispersion"
#'   differences.
#' @param perturb Boolean, if TRUE, adds small noise to data to avoid ties and
#'   improve model stability.
#' @return Returns the p-value of the test if `p_value` is TRUE, otherwise
#'   returns test statistics and weights.
#' @examples
#'
#' set.seed(1)
#' data <- c(
#'     rnbinom(100, size = 2, mu = 20), rnbinom(100, size = 2, mu = 25),
#'     rnbinom(100, size = 2, mu = 30)
#' )
#' labels <- factor(c(rep("Group1", 100), rep("Group2", 100), 
#'           rep("Group3", 100)))
#' QRscore_ZINB_nSamples(
#'     samples = data, labels = labels,
#'     zero_inflation = FALSE, LR.test = FALSE, approx = "resample",
#'     resamp_num = 5000, pi_threshold = 0.95, measure = "mean"
#' )
#'
#' # Example with zero inflation and dispersion shift detection
#' data_zi <- c(
#'     rzinbinom(100, size = 2, mu = 20, pi = 0.1),
#'     rzinbinom(100, size = 3, mu = 20, pi = 0.1),
#'     rzinbinom(100, size = 4, mu = 20, pi = 0.1)
#' )
#' labels_zi <- factor(c(rep("Group1", 100), rep("Group2", 100), 
#'               rep("Group3", 100)))
#' QRscore_ZINB_nSamples(
#'     samples = data_zi, labels = labels_zi,
#'     zero_inflation = TRUE, LR.test = TRUE, approx = "asymptotic",
#'     resamp_num = 2000, pi_threshold = 0.95, measure = "dispersion"
#' )
#' # Multi-sample NB example with size factors
#' sf <- runif(300, 0.5, 1.5)
#' data_sf <- c(
#'     rnbinom(100, size = 2, mu = sf[1:100] * 20),
#'     rnbinom(100, size = 2, mu = sf[101:200] * 30),
#'     rnbinom(100, size = 2, mu = sf[201:300] * 40)
#' )
#' labels_sf <- factor(rep(c("Group1", "Group2", "Group3"), each = 100))
#' QRscore_ZINB_nSamples(
#'     samples = data_sf, labels = labels_sf, size_factors = sf,
#'     zero_inflation = FALSE, LR.test = FALSE, approx = "asymptotic",
#'     resamp_num = 10000, pi_threshold = 0.95, measure = "mean"
#' )
#' @export
QRscore_ZINB_nSamples <- function(samples, labels, size_factors = NULL,
                                  zero_inflation = TRUE,
                                  LR.test = FALSE, approx = "resample",
                                  resamp_num = 20000, pi_threshold = 0.95,
                                  gene.name = NULL, measure = "mean",
                                  perturb = TRUE) {
    unique_labels <- unique(labels)
    n_groups <- length(unique_labels)
    sample_list <- lapply(unique_labels, function(l) {
        samples[labels == l]
    })
    if (!is.null(size_factors)) {
        norm_samples <- samples / size_factors
        norm_sample_list <- lapply(unique_labels, function(l) {
            norm_samples[labels == l]
        })
        size_factors_reordered <- lapply(unique_labels, function(l) {
            size_factors[labels == l]
        })
        size_factor_x <- size_factors_reordered[[1]]
        size_factor_y <- unlist(size_factors_reordered[-1], use.names = FALSE)
        size_factors <- c(size_factor_x, size_factor_y)
    } else {
        norm_sample_list <- sample_list
    }

    group_sizes <- vapply(sample_list, length, integer(1))
    N_all <- sum(group_sizes)
    B_matrix <- .generateBMatrix(n_groups)
    group_proportion <- group_sizes / N_all
    AA_matrix <- .generateAAmatrix(group_proportion)

    x <- sample_list[[1]]
    y <- unlist(sample_list[-1], use.names = FALSE)
    results <- QRscore_ZINB(x, y, size_factors = size_factors,
                            zero_inflation = zero_inflation,
                            LR.test = LR.test, approx = approx,
                            resamp_num = resamp_num,
                            pi_threshold = pi_threshold, gene.name = gene.name,
                            measure = measure, p_value = FALSE
    )

    if (!is.list(results) || is.null(results$weight)) {
        return(NA)
    }

    weights <- results$weight
    S_scores <- .computeSscores(norm_sample_list, weights, N_all)
    Lambda_matrix <- diag(1 / sqrt(group_proportion))
    Test_vec <- t(B_matrix) %*% Lambda_matrix %*% S_scores
    H_new <- .get_H_new(results$var, B_matrix, AA_matrix, gene.name)
    H_inv <- .get_H_inv(H_new, gene.name)
    if (is.na(H_inv)[1]) {
        return(NA)
    }

    Q_all <- t(Test_vec) %*% H_inv %*% Test_vec
    p.value <- pchisq(Q_all, df = n_groups - 1, lower.tail = FALSE)
    return(p.value[1, 1])
}



#' QRscore Test
#'
#' This function performs statistical tests on data from one or more groups 
#' using summary statistics computed on weighted linear combinations of powers 
#' of spacing statistics. It is capable of conducting one-sample tests, 
#' two-sample tests, and multi-sample tests, utilizing either user-defined 
#' weights or automatically generated weights based on Negative Binomial (NB) 
#' or Zero-Inflated Negative Binomial (ZINB) models.
#'
#' For one-sample tests, the function assesses the uniformity of data entries.
#' For two-sample and multi-sample tests, it evaluates whether groups are drawn
#' from the same distribution, with alternative hypotheses considering
#' differences in means or dispersions.
#'
#' If the weights and \eqn{p} are given, the function calculates the test
#' statistic as: \deqn{||S_k||_{p,\boldsymbol{w}}^p=\sum_{j=1}^k
#' w_iS_{k}[j]^p} where \eqn{w_i} are weights, \eqn{x_i} are data points, and
#' \eqn{p} is the power specified.
#'
#' In two-sample and multi-sample settings without specified weights, the
#' function can automatically estimate weights using score function for a
#' Negative Binomial or a Zero-Inflated Negative Binomial model, optimizing for
#' dispersion or mean shifts.
#'
#' @param samples A numeric vector containing all sample measurements.
#' @param labels An optional vector of group labels corresponding to each entry
#'   in `samples`.
#' @param size_factors Optional vector of size factors for weight estimation.
#'  If provided, log-transformed size factors are used as offsets in 
#'  NB/ZINB model fitting.
#' @param p The exponent used in the power sum test statistic, required if
#'   `wList` is not `NULL`.
#' @param wList An optional vector of weights; if `NULL`, weights are estimated
#'   using an NB or ZINB model for multiple groups.
#' @param alternative Specifies the alternative hypothesis; must be one of
#'   "two.sided", "greater", or "less".
#' @param approx The method used for p-value approximation, either "resample" or
#'   "asymptotic".
#' @param type Specifies if the estimation of the p-value should be "unbiased",
#'   "valid", or "both".
#' @param n_mom The number of moments to accompany the approximation, relevant
#'   for moment-based methods.
#' @param resamp_number The number of resampling iterations used if `approx` is
#'   "resample".
#' @param zero_inflation Indicates whether to account for zero inflation in
#'   model-based weight estimation.
#' @param LR.test Whether a likelihood ratio test is used to decide between NB
#'   and ZINB models.
#' @param pi_threshold Threshold for the proportion of zeros in ZINB models;
#'   results in NA if exceeded.
#' @param gene.name Optional identifier for a gene, used in output messages.
#' @param measure Specifies the statistical measure to be analyzed ("mean" or
#'   "dispersion") when weights are auto-generated.
#' @param perturb Boolean to indicate if data should be perturbed slightly to
#'   prevent ties.
#' @param use_base_r Boolean to decide whether to use base R functions for
#'   certain edge cases like Mann-Whitney tests.
#' @return Returns the p-value of the test.
#' @examples
#'
#' set.seed(1)
#' # One-sample test example with normally distributed data
#' data <- abs(rnorm(10))
#' QRscoreTest(data,
#'     p = 2, wList = rep(1, 10), alternative = "two.sided",
#'     approx = "resample"
#' )
#'
#' # Two-sample test with specified weights using normally distributed data
#' group1 <- rnorm(120, sd = 1)
#' group2 <- rnorm(120, sd = 2) # Different mean
#' data <- c(group1, group2)
#' labels <- c(rep("Group1", 120), rep("Group2", 120))
#' QRscoreTest(
#'     samples = data, labels = labels, p = 1, wList = c(60:0, seq_len(60)),
#'     alternative = "two.sided", approx = "resample"
#' )
#'
#' # Two-sample test with automatically estimated weights from NB model
#' group1 <- rzinbinom(120, size = 2, mu = 20, pi = 0)
#' group2 <- rzinbinom(100, size = 2, mu = 30, pi = 0) # Different mean
#' data <- c(group1, group2)
#' labels <- c(rep("Group1", 120), rep("Group2", 100))
#' QRscoreTest(
#'     samples = data, labels = labels,
#'     approx = "asymptotic", measure = "mean", zero_inflation = FALSE
#' )
#'
#' # Two-sample test with automatically estimated weights from ZINB model
#' group1 <- rzinbinom(100, size = 2, mu = 40, pi = 0.1)
#' group2 <- rzinbinom(200, size = 1, mu = 40, pi = 0.1)
#' data <- c(group1, group2)
#' labels <- c(rep("Group1", 100), rep("Group2", 200))
#' QRscoreTest(
#'     samples = data, labels = labels, alternative = "two.sided",
#'     approx = "asymptotic", measure = "dispersion"
#' )
#'
#' # Three-sample test with automatically estimated weights from NB model
#' group1 <- rzinbinom(150, size = 1, mu = 30, pi = 0.1)
#' group2 <- rzinbinom(100, size = 2, mu = 30, pi = 0.1)
#' group3 <- rzinbinom(30, size = 3, mu = 30, pi = 0.1)
#' data <- c(group1, group2, group3)
#' labels <- c(rep("Group1", 150), rep("Group2", 100), rep("Group3", 30))
#' QRscoreTest(
#'     samples = data, labels = labels, alternative = "two.sided",
#'     approx = "asymptotic", measure = "dispersion"
#' )
#' 
#' # Two-sample NB test with size factors
#' sf <- runif(200, 0.5, 1.5)
#' x <- rnbinom(100, size = 2, mu = sf[1:100] * 20)
#' y <- rnbinom(100, size = 2, mu = sf[101:200] * 35)
#' QRscoreTest(
#'     samples = c(x, y), labels = rep(c("A", "B"), each = 100),
#'     size_factors = sf, measure = "mean", zero_inflation = FALSE
#' )
#' @export
#' 
QRscoreTest <- function(samples, labels = NULL, size_factors = NULL, p = NULL, 
                        wList = NULL, alternative = "two.sided",
                        approx = "resample", type = "unbiased",
                        n_mom = 100, resamp_number = 5000,
                        zero_inflation = TRUE, LR.test = FALSE,
                        pi_threshold = 0.95, gene.name = NULL,
                        measure = "mean", perturb = TRUE,
                        use_base_r = TRUE) {
    tryCatch({
        assertthat::assert_that(!is.null(samples),
                                msg = "Samples cannot be NULL."
        )
        assertthat::assert_that(
            alternative %in% c("two.sided", "greater", "less"),
            msg = "Invalid alternative value."
        )
        assertthat::assert_that(
            approx %in% c("resample", "asymptotic"),
            msg = "Invalid approximation method."
        )
        assertthat::assert_that(
            type %in% c("unbiased", "valid", "both"), msg = "Invalid type value."
        )
        if (is.null(labels) || length(unique(labels)) == 1) {
            return(.run_qrscore_one_sample(
                samples, p, wList, alternative, approx, type, n_mom, 
                resamp_number))
        }
        assertthat::assert_that(length(labels) == length(samples),
                                msg = "Sample and label lengths must match."
        )
        unique_labels <- sort(unique(labels))
        n_groups <- length(unique_labels)
        sample_list <- lapply(unique_labels, function(l) {
            samples[labels == l]
        })
        if (!is.null(size_factors)) {
            size_factor_list <- lapply(unique_labels, function(l) {
                size_factors[labels == l]
            })
        } else {
            size_factor_list <- NULL
        }

        if (n_groups == 2) {
            return(.run_qrscore_two_sample(
                sample_list, unique_labels, alternative, approx, resamp_number,
                zero_inflation, LR.test, pi_threshold, gene.name, measure, p,
                wList, type, n_mom, use_base_r, size_factor_list
            ))
        }
        message(
            date(), ": Performing multi-sample test. Use ZINB or NB model to",
            " estimate the weights."
        )
        return(QRscore_ZINB_nSamples(
            samples, labels, size_factors, zero_inflation, LR.test, approx, 
            resamp_number, pi_threshold, gene.name, measure, perturb
        ))
    }, error = function(e) {
        warning(sprintf("QRscoreTest failed: %s", conditionMessage(e)))
        return(NA)
    })
}

# Test QRscore_Flex function for one-sample case
test_that("QRscore_Flex handles one-sample case correctly", {
    set.seed(1)
    x <- abs(rnorm(10))
    wList <- rep(1, 10)
    p_value <- QRscore_Flex(
        x = x, p = 2, wList = wList,
        alternative = "two.sided", approx = "resample"
    )
    expect_true(is.numeric(p_value))
    expect_true(p_value <= 1 & p_value >= 0)
})

# Test QRscore_Flex function for two-sample case
test_that("QRscore_Flex handles two-sample case correctly", {
    set.seed(1)
    x <- abs(rnorm(30))
    y <- abs(rnorm(100))
    wList <- rep(1, 31)
    p_value <- QRscore_Flex(
        x = x, y = y, p = 2, wList = wList,
        alternative = "two.sided", approx = "resample",
        resamp_number = 5000
    )
    expect_true(is.numeric(p_value))
    expect_true(p_value <= 1 & p_value >= 0)
})

# Test QRscore_Flex function for two-sample case with asymptotic approximation
test_that("QRscore_Flex handles two-sample approximation correctly", {
    set.seed(1)
    x <- abs(rnorm(100))
    y <- abs(rnorm(100))
    wList <- 0:100
    p_value <- QRscore_Flex(
        x = x, y = y, p = 1, wList = wList,
        alternative = "two.sided",
        approx = "asymptotic"
    )
    expect_true(is.numeric(p_value))
    expect_true(p_value <= 1 & p_value >= 0)
})


# Test QRscore_ZINB
test_that("QRscore_ZINB runs without error and returns numeric", {
    set.seed(1)
    x <- rzinbinom(30, size = 2, mu = 20, pi = 0.1)
    y <- rzinbinom(30, size = 1, mu = 20, pi = 0.1)

    p_value <- QRscore_ZINB(x, y,
        zero_inflation = TRUE, LR.test = FALSE,
        alternative = "two.sided", approx = "asymptotic", 
        measure = "dispersion"
    )
    expect_true(p_value <= 1 & p_value >= 0)
    expect_true(is.numeric(p_value))
})


test_that("QRscore_ZINB identifies distribution differences correctly", {
    n_sim <- 500 # Number of simulations
    pvalues_null <- numeric(n_sim)
    pvalues_alt <- numeric(n_sim)

    for (i in seq_len(n_sim)) {
        # Null hypothesis: both samples from the same distribution
        x_null <- rnbinom(100, size = 2, mu = 20)
        y_null <- rnbinom(100, size = 2, mu = 20)
        pvalues_null[i] <- QRscore_ZINB(x_null, y_null,
            zero_inflation = FALSE, LR.test = FALSE,
            alternative = "two.sided", approx = "asymptotic", measure = "mean"
        )

        # Alternative hypothesis: samples from different distributions
        x_alt <- rnbinom(100, size = 2, mu = 20)
        y_alt <- rnbinom(100, size = 10, mu = 20)
        pvalues_alt[i] <- QRscore_ZINB(x_alt, y_alt,
            zero_inflation = FALSE, LR.test = FALSE,
            alternative = "two.sided", approx = "asymptotic", 
            measure = "dispersion"
        )
    }

    prop_null <- mean(pvalues_null < 0.05, na.rm = TRUE)
    prop_alt <- mean(pvalues_alt < 0.05, na.rm = TRUE)

    expect_true(prop_null <= 0.07)
    expect_true(prop_alt > 0.05)
})

#' Example Dataset for MOCHIS DEG Analysis
#'
#' This dataset contains a subset of rounded normalized gene expression counts
#' from GTEx whole blood tissue and associated labels for demonstration
#' purposes.
#'
#' @format This dataset contains the following objects:
#' \describe{
#'   \item{example_data1}{A numeric matrix of normalized counts for all age
#'   groups.}
#'   \item{labels1}{A vector of sample labels for all age groups.}
#'   \item{example_data2}{A numeric matrix of normalized counts for age groups
#'   20-39 and 60-79.}
#'   \item{labels2}{A vector of sample labels for age groups 20-39 and 60-79.}
#' }
#' @source Normalized counts from GTEx for package demonstration purposes.
#' @examples
#' data(example_dataset)
example_dataset <- NULL


#' Example Dataset for MOCHIS DEG Analysis with Raw Counts
#'
#' This dataset contains raw gene expression counts from 3000 genes in GTEx
#' whole blood tissue for demonstration purposes.
#'
#' @format This dataset contains a list with the following components
#' \describe{
#'   \item{COUNTS}{A numeric matrix of raw counts for 3000 genes.}
#'   \item{METADATA}{The metadata for the corresponding raw counts.}
#' }
#' @source Raw counts from GTEx for package demonstration purposes.
#' @examples
#' data(example_dataset_raw_3000_genes)
example_dataset_raw_3000_genes <- NULL

#' QRscore: Nonparametric Quantile Rank Score Tests for Distributional Shifts 
#' in Gene Expression
#'
#' The QRscore package implements a family of nonparametric two-sample, and 
#' multi-sample tests for detecting shifts in central tendency (mean) and 
#' spread (variance/dispersion) in gene expression data.
#' The package includes functionality for negative binomial and zero-inflated 
#' negative binomial models, resampling-based and asymptotic approximations, 
#' and is designed to be robust, flexible and efficient.
#'
#' @section Main Functions:
#' - [`QRscoreTest()`]: Wrapper for one-, two-, and multi-sample QRscore tests.
#' - [`QRscoreGenetest()`]: DE pipeline over many genes.
#'
#' @docType package
#' @name QRscore
#' @aliases QRscore-package
#' @importFrom stats pnorm qnbinom dnbinom rnbinom
#' @importFrom pscl zeroinfl
#' @importFrom MASS glm.nb
#' @importFrom assertthat assert_that
#' @importFrom arrangements compositions
#' @importFrom hitandrun simplex.sample
#' @importFrom BiocParallel bplapply SerialParam MulticoreParam
#' @importFrom dplyr %>%
#' @keywords package
"_PACKAGE"

---
title: "Quantile Rank Score (QRscore): Quick Start"
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
    number_sections: true
    fig_caption: true
vignette: >
  %\VignetteEngine{BiocStyle::html_document}
  %\VignetteIndexEntry{QRscore}
  %\VignetteEncoding{UTF-8}
---


# Introduction

Differential expression (DE) analysis, aiming to identify genes with 
significant expression changes across conditions, provides insights into 
molecular mechanisms underlying aging, disease, and other biological processes. 
Traditional DE methods primarily detect changes in centrality (e.g., mean or 
median), but often lack power against alternative hypotheses characterized by 
changes in spread (e.g. variance or dispersion). Variance shifts, however, are 
critical in understanding regulatory dynamics and stochasticity in gene 
expression, particularly in contexts like aging and cellular differentiation. 
Moreover, in DE analysis, there is often a trade-off between statistical power 
and control over the false discovery rate (FDR): parametric approaches may 
inflate FDRs, while nonparametric methods frequently lack sufficient power.

The `QRscore` package addresses these two limitations by providing a robust 
framework for two-sample and K-sample tests that detect shifts in both 
centrality and spread. Built upon rigorous theoretical foundations,`QRscore` 
extends the Mann-Whitney test to an adaptive, rank-based approach that combines 
non-parametric tests with weights informed by (zero-inflated) negative binomial 
models, ensuring both high power and strictly controlled FDR. 

This package is designed to complement existing tools in Bioconductor by 
offering enhanced capabilities for detecting distributional shifts. By 
integrating with widely-used Bioconductor packages such as `DESeq2` and 
leveraging parallelization (`BiocParallel`), `QRscore` seamlessly integrates 
into genomics workflows for differential expression and differential dispersion 
analysis. This vignette demonstrates the utility of `QRscore` through a 
detailed example.

# Installation

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE
)
```

Check dependencies are installed.

```{r eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}
if (!requireNamespace("DESeq2", quietly = TRUE)) {
    BiocManager::install("DESeq2")
}
```

You can install the QRscore package from 
[Bioconductor](https://bioconductor.org) with the following command:

```{r eval = FALSE}
if (!requireNamespace("QRscore", quietly = TRUE)) {
    BiocManager::install("QRscore")
}
```


Alternatively, you can install the QRscore package from github:

```{r eval = FALSE}
if (!requireNamespace("devtools", quietly = TRUE)) {
    install.packages("devtools")
}
devtools::install_github("Fanding-Zhou/QRscore")
```

# Overview

This vignette illustrates how to:

1. Preprocess and normalize bulk RNA-seq data.

2. Perform two-sample and three-sample differential tests using `QRscore`.

3. Obtain results for DEGs and DDGs.


# Analysis

Here are detailed steps of using the package for analysis.

## Package Loading

```{r}
library(QRscore)
library(DESeq2)
```


## Load the data

The example dataset contains 3000 randomly selected genes in RNA-seq counts 
data from whole blood samples in the GTEx project, along with associated 
metadata for age groups.

```{r}
data("example_dataset_raw_3000_genes")
```


Age groups are aggregated for larger sample size and simplified analysis.

```{r}
bulk_sparse_mat <- example_dataset_raw_3000_genes$COUNTS
ages <- example_dataset_raw_3000_genes$METADATA$AGE
ages[ages %in% c("20-29", "30-39")] <- "20-39"
ages[ages %in% c("40-49", "50-59")] <- "40-59"
ages[ages %in% c("60-69", "70-79")] <- "60-79"
```

## Data Prefiltering and Normalization

* Genes with low expression or high dropout rates are excluded.

* The `DESeq2` package is used to normalize the filtered gene expression matrix.

```{r message=FALSE, warning=FALSE}
col_means <- colMeans(bulk_sparse_mat, na.rm = TRUE)
col_zeros <- colMeans(bulk_sparse_mat == 0, na.rm = TRUE)
# The following threshold can be modified
col_ids <- which(col_means > 5 & col_zeros < 0.2)

bulk_df <- bulk_sparse_mat[, col_ids]
expr_mat <- t(bulk_df)
coldata <- data.frame(age = ages)
dds <- DESeqDataSetFromMatrix(
    countData = expr_mat,
    colData = coldata,
    design = ~age
)
dds <- estimateSizeFactors(dds)
est_size_factors = dds$sizeFactor
```

```{r}
print("Number of kept genes after prefiltering:")
print(length(col_ids))
```

## Two-sample test 

### Define Age Groups for Testing

This example compares the 20-39 and 60-79 age groups.

```{r}
## define age groups and subset dataset
kept_samples <- coldata$age %in% c("20-39", "60-79")
expr_mat_1 <- expr_mat[, kept_samples] # directly use raw counts
est_size_factors_1 <- est_size_factors [kept_samples]
coldata_1 <- coldata[kept_samples,]
```

### Run QRscore Test

Both mean and dispersion shifts are tested in parallel. The outputs includes 
ranked p-values of differential variance and differential mean tests for 
all genes, together with log ratio of mean shifts and variance shifts.

```{r}
results_2_sample <- QRscoreGenetest(expr_mat_1,
    coldata_1,
    size_factors = est_size_factors_1,
    pairwise_test = TRUE,
    pairwise_logFC = TRUE, test_mean = TRUE,
    test_dispersion = TRUE, num_cores = 2,
    approx = "asymptotic"
)
```




### Differentially Expressed Genes (DEGs)

Genes with significant mean shifts are identified.

```{r}
results_2_sample_mean <- results_2_sample$mean_test
results_2_sample_DEG <-
    results_2_sample_mean[
        results_2_sample_mean$QRscore_Mean_adj_p_value < 0.05,
    ]
head(results_2_sample_DEG)
```


### Differentially Dispersed Genes (DDGs)

Genes with significant variance shifts are identified.

```{r}
results_2_sample_var <- results_2_sample$var_test
results_2_sample_DDG <-
    results_2_sample_var[results_2_sample_var$QRscore_Var_adj_p_value < 0.05, ]
head(results_2_sample_DDG)
```



## Three-Sample Test

This example compares the 20-39, 40-59, and 60-79 age groups. 

The output includes 3-sample test p-values as well as pairwise fold changes.
To get a more comprehensive result, one can set `pairwise_test = TRUE` to 
additionally obtain the pairwise test p-values.


```{r}
results_3_sample <- QRscoreGenetest(
    expr_mat, coldata$age, size_factors = est_size_factors,
    pairwise_test = FALSE,
    pairwise_logFC = TRUE, test_mean = TRUE,
    test_dispersion = TRUE, num_cores = 2,
    approx = "asymptotic"
)
```



For detecting DDGs and DEGs, it's recommended to use 3-sample test p-values 
(namely `QRscore_Mean_adj_p_value` and `QRscore_Var_adj_p_value`) with certain 
cutoffs (e.g. 0.05).


```{r}
### DEGs
results_3_sample_mean <- results_3_sample$mean_test
results_3_sample_DEG <- results_3_sample_mean[
    results_3_sample_mean$QRscore_Mean_adj_p_value < 0.05,
]
head(results_3_sample_DEG)
```

```{r}
### DDGs
results_3_sample_var <- results_3_sample$var_test
results_3_sample_DDG <-
    results_3_sample_var[results_3_sample_var$QRscore_Var_adj_p_value < 0.05, ]
head(results_3_sample_DDG)
```




# Session Info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getCompositionPValue}
\alias{getCompositionPValue}
\title{Approximate p-value by Resampling Integer Compositions}
\usage{
getCompositionPValue(t, n, k, p, wList, alternative, type, resamp_number)
}
\arguments{
\item{t}{Value of test statistic \eqn{||S_{n,k}(D)/n||_{p,\boldsymbol{w}}^p}
computed from data \eqn{D}}

\item{n}{Sample size of \eqn{y}}

\item{k}{Sample size of \eqn{x}}

\item{p}{Power exponent of test statistic}

\item{wList}{Weight vector}

\item{alternative}{Character string that should be one of "\code{two.sided}"
(default), "\code{greater}" or "\code{less}"}

\item{type}{If using resampling approximation, either an unbiased estimate
of ("\code{unbiased}", default), or valid, but biased estimate of, ("\code{valid}")
p-value (see Hemerik and Goeman, 2018), or both ("\code{both}").
Default is "\code{unbiased}".}

\item{resamp_number}{Number of compositions of \eqn{n} to draw
(default is 5000)}
}
\value{
p-value (scalar)
}
\description{
Given the value of the test statistic \eqn{t}, the sample sizes \eqn{n} and
\eqn{k},power exponent \eqn{p} and vector of weights that together determine
the test statistic (by default \eqn{n\geqslant k}), as well as the
user-specified resampling number (by default this is \eqn{5000}),
performs resampling from the collection of integer compositions
to approximate the p-value of the observed test statistic.
}
\details{
For \eqn{n} and \eqn{k} small enough (\eqn{n\leqslant 40, k\leqslant 10}),
computes exact p-value by computing the test statistic across all
\eqn{k}-compositions of \eqn{n} under the uniform distribution.

The function returns a two-sided p-value by default, which is more
conservative. Users can choose other p-values corresponding to different
alternatives; see documentation on \code{alternative}. Note that the
interpretation of the choice of \code{alternative} depends on the choice of
weight vector. For example, a weight vector that is a quadratic kernel will
upweight the extreme components of the weight vector. For this choice,
setting \code{alternative} to be \code{greater} translates into an alternative
hypothesis of a bigger spread in the larger sample
(the one with sample size \eqn{n}).

Dependencies: arrangements::compositions
}
\examples{

getCompositionPValue(
    t = 0.5, n = 50, k = 11, p = 1, wList = (10:0) / 10,
    alternative = "two.sided", type = "unbiased", resamp_number = 5000
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{rzinbinom}
\alias{rzinbinom}
\title{Generate random samples from a zero-inflated negative binomial distribution}
\usage{
rzinbinom(n, mu, theta, size, pi)
}
\arguments{
\item{n}{Integer. Number of samples to generate.}

\item{mu}{Numeric. Mean of the negative binomial distribution.}

\item{theta}{Numeric. Dispersion parameter (size) of the negative binomial
distribution.}

\item{size}{Numeric. Alternative name for the dispersion parameter
(used interchangeably with \code{theta}).}

\item{pi}{Numeric. Zero-inflation probability; must be in the range
\eqn{[0,1]}.}
}
\value{
A vector of random samples from a Zero-Inflated Negative Binomial
(ZINB) distribution.
}
\description{
Generate random samples from a zero-inflated negative binomial distribution
}
\examples{
set.seed(1)
rzinbinom(n = 5, mu = 10, theta = 5, pi = 0.2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QRscore.R
\name{QRscore_ZINB_nSamples}
\alias{QRscore_ZINB_nSamples}
\title{Multi-Sample Nonparametric Test for Mean or Dispersion Differences in
(Zero-Inflated) Negative Binomial Distributions.}
\usage{
QRscore_ZINB_nSamples(
  samples,
  labels,
  size_factors = NULL,
  zero_inflation = TRUE,
  LR.test = FALSE,
  approx = "resample",
  resamp_num = 20000,
  pi_threshold = 0.95,
  gene.name = NULL,
  measure = "mean",
  perturb = TRUE
)
}
\arguments{
\item{samples}{Vector of all sample measurements.}

\item{labels}{Group labels for each sample.}

\item{size_factors}{Optional vector of size factors for weight estimation.
If provided, log-transformed size factors are used as offsets in
NB/ZINB model fitting.}

\item{zero_inflation}{Boolean, if TRUE, the function chooses between ZINB and
NB models based on data; if FALSE, only NB model is applied.}

\item{LR.test}{Boolean, if TRUE, performs a likelihood ratio test to select
between NB and ZINB models.}

\item{approx}{The method used for p-value approximation; "resample"
(default) or "asymptotic".}

\item{resamp_num}{The number of resampling iterations used if \code{approx} is
"resample".}

\item{pi_threshold}{Threshold for proportion of zeros at which to return NA,
indicating unreliable results due to excessive zero inflation.}

\item{gene.name}{Optional, name of the gene if applicable, enhancing the
relevance of output in genetic studies.}

\item{measure}{Specifies whether the test focuses on "mean" or "dispersion"
differences.}

\item{perturb}{Boolean, if TRUE, adds small noise to data to avoid ties and
improve model stability.}
}
\value{
Returns the p-value of the test if \code{p_value} is TRUE, otherwise
returns test statistics and weights.
}
\description{
This function conducts statistical tests across multiple samples to evaluate
the null hypothesis that all groups are drawn from the same distribution. It
is optimized for data modeled by Negative Binomial (NB) or Zero-Inflated
Negative Binomial (ZINB) distributions and is capable of detecting shifts in
mean or dispersion parameters. The function can handle any number of groups
and automatically computes optimal weights for the specified measure (mean or
dispersion).
}
\details{
The computation involves constructing a B matrix that transforms
group-specific scores into a space where independence among groups is
maximized. It then uses these transformed scores to calculate a test
statistic, which follows a chi-square distribution under the null
hypothesis.

Additional tuning parameters allow customization of the model fitting and
statistical testing, including:
\itemize{
\item Selection between NB and ZINB models based on presence of zero inflation.
\item Choice of approximation method for computing p-values - 'asymptotic' is
recommended.
\item Decision criteria for statistical tests (one-sided or two-sided).
\item Threshold for the estimated proportion of zeros beyond which results are
considered unreliable.
}

Dependencies: Requires \code{pscl::zeroinfl} for zero-inflated models,
\code{MASS::glm.nb} for NB models, and other auxiliary functions as needed.
}
\examples{

set.seed(1)
data <- c(
    rnbinom(100, size = 2, mu = 20), rnbinom(100, size = 2, mu = 25),
    rnbinom(100, size = 2, mu = 30)
)
labels <- factor(c(rep("Group1", 100), rep("Group2", 100), 
          rep("Group3", 100)))
QRscore_ZINB_nSamples(
    samples = data, labels = labels,
    zero_inflation = FALSE, LR.test = FALSE, approx = "resample",
    resamp_num = 5000, pi_threshold = 0.95, measure = "mean"
)

# Example with zero inflation and dispersion shift detection
data_zi <- c(
    rzinbinom(100, size = 2, mu = 20, pi = 0.1),
    rzinbinom(100, size = 3, mu = 20, pi = 0.1),
    rzinbinom(100, size = 4, mu = 20, pi = 0.1)
)
labels_zi <- factor(c(rep("Group1", 100), rep("Group2", 100), 
              rep("Group3", 100)))
QRscore_ZINB_nSamples(
    samples = data_zi, labels = labels_zi,
    zero_inflation = TRUE, LR.test = TRUE, approx = "asymptotic",
    resamp_num = 2000, pi_threshold = 0.95, measure = "dispersion"
)
# Multi-sample NB example with size factors
sf <- runif(300, 0.5, 1.5)
data_sf <- c(
    rnbinom(100, size = 2, mu = sf[1:100] * 20),
    rnbinom(100, size = 2, mu = sf[101:200] * 30),
    rnbinom(100, size = 2, mu = sf[201:300] * 40)
)
labels_sf <- factor(rep(c("Group1", "Group2", "Group3"), each = 100))
QRscore_ZINB_nSamples(
    samples = data_sf, labels = labels_sf, size_factors = sf,
    zero_inflation = FALSE, LR.test = FALSE, approx = "asymptotic",
    resamp_num = 10000, pi_threshold = 0.95, measure = "mean"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QRscore-package.R
\docType{package}
\name{QRscore}
\alias{QRscore}
\alias{QRscore-package}
\title{QRscore: Nonparametric Quantile Rank Score Tests for Distributional Shifts
in Gene Expression}
\description{
The QRscore package implements a family of nonparametric two-sample, and
multi-sample tests for detecting shifts in central tendency (mean) and
spread (variance/dispersion) in gene expression data.
The package includes functionality for negative binomial and zero-inflated
negative binomial models, resampling-based and asymptotic approximations,
and is designed to be robust, flexible and efficient.
}
\section{Main Functions}{

\itemize{
\item \code{\link[=QRscoreTest]{QRscoreTest()}}: Wrapper for one-, two-, and multi-sample QRscore tests.
\item \code{\link[=QRscoreGenetest]{QRscoreGenetest()}}: DE pipeline over many genes.
}
}

\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/songlab-cal/QRscore}
  \item Report bugs at \url{https://github.com/songlab-cal/QRscore/issues}
}

}
\author{
\strong{Maintainer}: Fanding Zhou \email{zhoufd@berkeley.edu} (\href{https://orcid.org/0000-0003-1306-740X}{ORCID})

Authors:
\itemize{
  \item Alan Aw \email{nalawanij@gmail.com} (\href{https://orcid.org/0000-0001-9455-7878}{ORCID})
  \item Dan Erdmann-Pham \email{erdpham@stanford.edu}
  \item Jonathan Fischer \email{jfischer1@ufl.edu} (\href{https://orcid.org/0000-0002-1165-9930}{ORCID})
}

Other contributors:
\itemize{
  \item Xurui Chen \email{xuruichen@berkeley.edu} [contributor]
}

}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{example_dataset}
\alias{example_dataset}
\title{Example Dataset for MOCHIS DEG Analysis}
\format{
This dataset contains the following objects:
\describe{
\item{example_data1}{A numeric matrix of normalized counts for all age
groups.}
\item{labels1}{A vector of sample labels for all age groups.}
\item{example_data2}{A numeric matrix of normalized counts for age groups
20-39 and 60-79.}
\item{labels2}{A vector of sample labels for age groups 20-39 and 60-79.}
}
}
\source{
Normalized counts from GTEx for package demonstration purposes.
}
\usage{
example_dataset
}
\description{
This dataset contains a subset of rounded normalized gene expression counts
from GTEx whole blood tissue and associated labels for demonstration
purposes.
}
\examples{
data(example_dataset)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{example_dataset_raw_3000_genes}
\alias{example_dataset_raw_3000_genes}
\title{Example Dataset for MOCHIS DEG Analysis with Raw Counts}
\format{
This dataset contains a list with the following components
\describe{
\item{COUNTS}{A numeric matrix of raw counts for 3000 genes.}
\item{METADATA}{The metadata for the corresponding raw counts.}
}
}
\source{
Raw counts from GTEx for package demonstration purposes.
}
\usage{
example_dataset_raw_3000_genes
}
\description{
This dataset contains raw gene expression counts from 3000 genes in GTEx
whole blood tissue for demonstration purposes.
}
\examples{
data(example_dataset_raw_3000_genes)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{rank_x}
\alias{rank_x}
\title{Retrieve indices of \eqn{x_i}'s after merging \eqn{\boldsymbol{x}} and
\eqn{\boldsymbol{y}} in ascending order.}
\usage{
rank_x(x, y = NULL, ties.break = TRUE)
}
\arguments{
\item{x}{First sample}

\item{y}{Second sample}

\item{ties.break}{Whether to break the ties when ordering \code{x} and \code{y}.
Default is \code{'TRUE'}.}
}
\value{
Ranks of \eqn{x_i}'s after merging \code{x} and \code{y} in ascending order
}
\description{
Given data consisting of either a single sample
\eqn{\boldsymbol{x}=(x_1,\ldots,x_k)},
or two samples \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)} and
\eqn{\boldsymbol{y}=(y_1,\ldots,y_n)},
this function obtains the indices of \eqn{x_i}'s after merging
\eqn{\boldsymbol{x}} and \eqn{\boldsymbol{y}} in ascending order.
}
\details{
Dependencies: None
}
\examples{

set.seed(1)
rank_x(x = abs(rnorm(10)))
rank_x(x = abs(rnorm(10)), y = abs(rnorm(100)))
rank_x(
    x = rnbinom(10, size = 5, prob = 0.3),
    y = rnbinom(20, size = 2, prob = 0.3), ties.break = TRUE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{computeweight_disp}
\alias{computeweight_disp}
\title{Compute weights for dispersion shift analysis}
\usage{
computeweight_disp(beta, mu, pi, n, k, tail = 10^(-4), bigN = 10^6)
}
\arguments{
\item{beta}{Target for number of successful trials, or dispersion parameter.
Must be strictly positive.}

\item{mu}{Non-negative mean of the uninflated negative binomial
distribution.}

\item{pi}{Zero inflation probability for structural zeros.}

\item{n}{Sample size of \eqn{y}}

\item{k}{Sample size of \eqn{x}}

\item{tail}{Distribution tail trimmed for numerically calculate expectation.
Default is \eqn{10^{-4}}}

\item{bigN}{Sampling numbers for numerically calculate expectation, this
will only be applied when mean parameter is extremely large.
Default is \eqn{10^6}}
}
\value{
A list containing a weight vector (\verb{$weight}) and estimated variance
(\verb{$var}) useful for constructing test statistics.
}
\description{
Given the value of the estimated parameters for zero-inflated negative
binomial distribution (\eqn{\beta}, \eqn{\mu}, \eqn{\pi}), the sample sizes
\eqn{n} and \eqn{k} (by default \eqn{n\geqslant k}), this function computes
weights that target on changes of the dispersion parameter in zero-inflated
negative binomial model.
}
\details{
The function returns a list containing a weight vector and estimated
variance for constructing test statistics.
}
\examples{

set.seed(1)
computeweight_disp(
    beta = 5, mu = 40, pi = 0.1, n = 100, k = 60,
    tail = 10^(-4), bigN = 10^6
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QRscore.R
\name{QRscore_Flex}
\alias{QRscore_Flex}
\title{Flexible Non-Parametric One- and Two-Sample Tests (Native R version)}
\usage{
QRscore_Flex(
  x,
  y = NULL,
  p = 1,
  wList,
  alternative = "two.sided",
  approx = "resample",
  type = "unbiased",
  n_mom = NULL,
  resamp_number = 5000
)
}
\arguments{
\item{x}{First sample}

\item{y}{Second sample}

\item{p}{Exponent value in defining test statistic (must be integer)}

\item{wList}{Vector of weights. It should have length equal to \eqn{x} when
\eqn{y} is \code{NULL}, and one more than the length of \eqn{x} when \eqn{y} is
not \code{NULL}}

\item{alternative}{How p-value should be computed; i.e., a character
specifying the alternative hypothesis, must be one of "\code{two.sided}",
"\code{greater}" or "\code{less}"}

\item{approx}{Which approximation method to use (choose "\code{resample}",
"\code{asymptotic}")}

\item{type}{If using resampling approximation, either an unbiased estimate of
("\code{unbiased}", default), or valid, but biased estimate of, ("\code{valid}")
p-value (see Hemerik and Goeman, 2018), or both ("\code{both}").
Default is "\code{unbiased}".}

\item{n_mom}{The number of moments to accompany the approximation
(recommended 200, if not at least 100)}

\item{resamp_number}{Number of \eqn{k}-compositions of \eqn{n} or simplex
vectors in \eqn{[0,1]^k}  to draw}
}
\value{
Returns the p-value.
}
\description{
Given data consisting of either a single sample
\eqn{\boldsymbol{x}=(x_1,\ldots,x_k)},
or two samples \eqn{\boldsymbol{x}=(x_1,\ldots,x_k)} and
\eqn{\boldsymbol{y}=(y_1,\ldots,y_n)},
this function uses summary statistics computed on weighted linear
combinations of powers of the spacing statistics
\eqn{S_k} (former) or \eqn{S_{n,k}} (latter).
}
\details{
More precisely, this function does the following:

For a single sample \eqn{x}, the function tests for uniformity of its
entries. When \eqn{p=2} and a particular choice of \eqn{\boldsymbol{w}} is
specified, we recover Greenwood's test.

For two samples, the function tests the null of \eqn{\boldsymbol{x}} and
\eqn{\boldsymbol{y}} being drawn from the same distribution
(i.e., stochastic equality), against flexible alternatives that correspond
to specific choices of the test statistic parameters, \eqn{\boldsymbol{w}}
(weight vector) and \eqn{p} (power). These parameters not only determine the
test statistic \eqn{||S_k||_{p,\boldsymbol{w}}^p=\sum_{j=1}^k w_iS_{k}[j]^p}
(analogously defined for \eqn{||S_{n,k}||_{p,\boldsymbol{w}}^p}), but also
encode alternative hypotheses ranging from different populational means
(i.e., \eqn{\mu_x \neq \mu_y}), different populational spreads
(i.e., \eqn{\sigma^2_x \neq \sigma^2_y}), etc.

Additional tuning parameters include:
(1) choice of p-value computation (one- or two-sided);
(2) approximation method
(3) number of moments accompanying the approximation chosen if using
moment-based approximation (recommended 200, typically at least 100); and
(4) in case of two samples, whether the user prefers to use exact discrete
moments (more accurate but slower) or to use continuous approximations of the
discrete moments (less accurate but faster).

Currently, only resampling and Gaussian asymptotics are supported.
Both are efficient and well-calibrated. For \eqn{n\geqslant 100} and
\eqn{k\geqslant 50} such that \eqn{\frac{k}{n}\geqslant 0.001},
function automatically uses Gaussian approximation to the null.

Dependencies: functions in \code{utils.R}
}
\examples{

set.seed(1)
# One-sample examples
QRscore_Flex(
    x = abs(rnorm(10)), p = 2, wList = rep(1, 10),
    alternative = "two.sided", approx = "resample"
)

# Two-sample examples
QRscore_Flex(
    x = abs(rnorm(30)), y = abs(rnorm(100)), p = 2,
    wList = rep(1, 31), alternative = "two.sided",
    approx = "resample", resamp_number = 5000
)

QRscore_Flex(
    x = abs(rnorm(100)), y = abs(rnorm(100)), p = 1,
    wList = 0:100, alternative = "two.sided",
    approx = "asymptotic"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QRscore.R
\name{QRscoreTest}
\alias{QRscoreTest}
\title{QRscore Test}
\usage{
QRscoreTest(
  samples,
  labels = NULL,
  size_factors = NULL,
  p = NULL,
  wList = NULL,
  alternative = "two.sided",
  approx = "resample",
  type = "unbiased",
  n_mom = 100,
  resamp_number = 5000,
  zero_inflation = TRUE,
  LR.test = FALSE,
  pi_threshold = 0.95,
  gene.name = NULL,
  measure = "mean",
  perturb = TRUE,
  use_base_r = TRUE
)
}
\arguments{
\item{samples}{A numeric vector containing all sample measurements.}

\item{labels}{An optional vector of group labels corresponding to each entry
in \code{samples}.}

\item{size_factors}{Optional vector of size factors for weight estimation.
If provided, log-transformed size factors are used as offsets in
NB/ZINB model fitting.}

\item{p}{The exponent used in the power sum test statistic, required if
\code{wList} is not \code{NULL}.}

\item{wList}{An optional vector of weights; if \code{NULL}, weights are estimated
using an NB or ZINB model for multiple groups.}

\item{alternative}{Specifies the alternative hypothesis; must be one of
"two.sided", "greater", or "less".}

\item{approx}{The method used for p-value approximation, either "resample" or
"asymptotic".}

\item{type}{Specifies if the estimation of the p-value should be "unbiased",
"valid", or "both".}

\item{n_mom}{The number of moments to accompany the approximation, relevant
for moment-based methods.}

\item{resamp_number}{The number of resampling iterations used if \code{approx} is
"resample".}

\item{zero_inflation}{Indicates whether to account for zero inflation in
model-based weight estimation.}

\item{LR.test}{Whether a likelihood ratio test is used to decide between NB
and ZINB models.}

\item{pi_threshold}{Threshold for the proportion of zeros in ZINB models;
results in NA if exceeded.}

\item{gene.name}{Optional identifier for a gene, used in output messages.}

\item{measure}{Specifies the statistical measure to be analyzed ("mean" or
"dispersion") when weights are auto-generated.}

\item{perturb}{Boolean to indicate if data should be perturbed slightly to
prevent ties.}

\item{use_base_r}{Boolean to decide whether to use base R functions for
certain edge cases like Mann-Whitney tests.}
}
\value{
Returns the p-value of the test.
}
\description{
This function performs statistical tests on data from one or more groups
using summary statistics computed on weighted linear combinations of powers
of spacing statistics. It is capable of conducting one-sample tests,
two-sample tests, and multi-sample tests, utilizing either user-defined
weights or automatically generated weights based on Negative Binomial (NB)
or Zero-Inflated Negative Binomial (ZINB) models.
}
\details{
For one-sample tests, the function assesses the uniformity of data entries.
For two-sample and multi-sample tests, it evaluates whether groups are drawn
from the same distribution, with alternative hypotheses considering
differences in means or dispersions.

If the weights and \eqn{p} are given, the function calculates the test
statistic as: \deqn{||S_k||_{p,\boldsymbol{w}}^p=\sum_{j=1}^k
w_iS_{k}[j]^p} where \eqn{w_i} are weights, \eqn{x_i} are data points, and
\eqn{p} is the power specified.

In two-sample and multi-sample settings without specified weights, the
function can automatically estimate weights using score function for a
Negative Binomial or a Zero-Inflated Negative Binomial model, optimizing for
dispersion or mean shifts.
}
\examples{

set.seed(1)
# One-sample test example with normally distributed data
data <- abs(rnorm(10))
QRscoreTest(data,
    p = 2, wList = rep(1, 10), alternative = "two.sided",
    approx = "resample"
)

# Two-sample test with specified weights using normally distributed data
group1 <- rnorm(120, sd = 1)
group2 <- rnorm(120, sd = 2) # Different mean
data <- c(group1, group2)
labels <- c(rep("Group1", 120), rep("Group2", 120))
QRscoreTest(
    samples = data, labels = labels, p = 1, wList = c(60:0, seq_len(60)),
    alternative = "two.sided", approx = "resample"
)

# Two-sample test with automatically estimated weights from NB model
group1 <- rzinbinom(120, size = 2, mu = 20, pi = 0)
group2 <- rzinbinom(100, size = 2, mu = 30, pi = 0) # Different mean
data <- c(group1, group2)
labels <- c(rep("Group1", 120), rep("Group2", 100))
QRscoreTest(
    samples = data, labels = labels,
    approx = "asymptotic", measure = "mean", zero_inflation = FALSE
)

# Two-sample test with automatically estimated weights from ZINB model
group1 <- rzinbinom(100, size = 2, mu = 40, pi = 0.1)
group2 <- rzinbinom(200, size = 1, mu = 40, pi = 0.1)
data <- c(group1, group2)
labels <- c(rep("Group1", 100), rep("Group2", 200))
QRscoreTest(
    samples = data, labels = labels, alternative = "two.sided",
    approx = "asymptotic", measure = "dispersion"
)

# Three-sample test with automatically estimated weights from NB model
group1 <- rzinbinom(150, size = 1, mu = 30, pi = 0.1)
group2 <- rzinbinom(100, size = 2, mu = 30, pi = 0.1)
group3 <- rzinbinom(30, size = 3, mu = 30, pi = 0.1)
data <- c(group1, group2, group3)
labels <- c(rep("Group1", 150), rep("Group2", 100), rep("Group3", 30))
QRscoreTest(
    samples = data, labels = labels, alternative = "two.sided",
    approx = "asymptotic", measure = "dispersion"
)

# Two-sample NB test with size factors
sf <- runif(200, 0.5, 1.5)
x <- rnbinom(100, size = 2, mu = sf[1:100] * 20)
y <- rnbinom(100, size = 2, mu = sf[101:200] * 35)
QRscoreTest(
    samples = c(x, y), labels = rep(c("A", "B"), each = 100),
    size_factors = sf, measure = "mean", zero_inflation = FALSE
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QRscore.R
\name{QRscore_ZINB}
\alias{QRscore_ZINB}
\title{Non-Parametric Two-Sample Tests Designed for Testing Differences in Mean or
Dispersion Parameters in (Zero-Inflated) Negative Binomial Distributions.}
\usage{
QRscore_ZINB(
  x,
  y,
  size_factors = NULL,
  zero_inflation = TRUE,
  LR.test = FALSE,
  approx = "resample",
  alternative = "two.sided",
  resamp_num = 20000,
  pi_threshold = 0.95,
  gene.name = NULL,
  measure = "mean",
  p_value = TRUE
)
}
\arguments{
\item{x}{First sample}

\item{y}{Second sample}

\item{size_factors}{Optional vector of size factors for weight estimation.
If provided, log-transformed size factors are used as offsets in
NB/ZINB model fitting.}

\item{zero_inflation}{If TRUE, automatically chooses between ZINB and NB
models based on the data; if FALSE, applies NB model estimation.}

\item{LR.test}{Whether to use a likelihood ratio test to determine which
model (NB or ZINB) to fit}

\item{approx}{Which approximation method to use (default \code{resample})}

\item{alternative}{How p-value should be computed; must be one of
"\code{two.sided}", "\code{greater}" or "\code{less}".}

\item{resamp_num}{Number of \eqn{k}-compositions of \eqn{n} or simplex
vectors in \eqn{[0,1]^k} to draw}

\item{pi_threshold}{Threshold for estimated proportion of zeros in ZINB model}

\item{gene.name}{Optional, name of the gene if applicable, used for
customized messages.}

\item{measure}{Specifies whether to test for shifts in "\code{mean}" or
"\code{dispersion}".}

\item{p_value}{If TRUE, returns a p-value, else returns test statistics and
weights.}
}
\value{
p-value or test statistics depending on \code{p_value} parameter.
}
\description{
This function evaluates the null hypothesis that two samples,
\eqn{\boldsymbol{x}} and \eqn{\boldsymbol{y}}, are drawn from the same
distribution, specifically designed for NB or ZINB models. It is particularly
effective in detecting shifts in either the mean or the dispersion
parameters.
}
\details{
The function automatically computes optimal weights for the chosen model and
derives a p-value based on the selected test statistic and approximation
method.

Additional tuning parameters include: (1) whether to use a likelihood ratio
test to determine which model (NB or ZINB) to fit, (2) the approximation
method (default is resampling, with asymptotic estimation for large
samples),(3) choice of p-value computation (one- or two-sided),
(4) threshold for estimated proportion of zeros in ZINB model
(returns NA if exceeded).

Dependencies: pscl::zeroinfl, MASS::glm.nb, and auxiliary functions from
\code{auxiliary.R}
}
\examples{

set.seed(1)
# Two-sample example comparing mean shifts
QRscore_ZINB(
    x = rzinbinom(100, size = 2, mu = 20, pi = 0),
    y = rzinbinom(100, size = 2, mu = 30, pi = 0),
    zero_inflation = FALSE, LR.test = FALSE, alternative = "greater",
    approx = "asymptotic", measure = "mean"
)

# Two-sample example comparing dispersion shifts
QRscore_ZINB(
    x = rzinbinom(100, size = 2, mu = 20, pi = 0.1),
    y = rzinbinom(100, size = 1, mu = 20, pi = 0.1),
    zero_inflation = TRUE, LR.test = TRUE, alternative = "two.sided",
    approx = "asymptotic", measure = "dispersion"
)

# Two-sample example with significant zero inflation and variance shift
QRscore_ZINB(
    x = rzinbinom(30, size = 4, mu = 20, pi = 0.1),
    y = rzinbinom(30, size = 1, mu = 20, pi = 0.3),
    zero_inflation = TRUE, LR.test = FALSE, alternative = "two.sided",
    approx = "resample", resamp_num = 50000, measure = "dispersion"
)
# Two-sample example with size factors, zero inflation, and dispersion shift
sf_x <- runif(100, 0.5, 1.5)
sf_y <- runif(100, 0.5, 1.5)
QRscore_ZINB(
    x = rzinbinom(100, size = 4, mu = sf_x * 25, pi = 0.1),
    y = rzinbinom(100, size = 1,   mu = sf_y * 25, pi = 0.1),
    size_factors = c(sf_x, sf_y),
    zero_inflation = TRUE, LR.test = TRUE, alternative = "two.sided",
    approx = "resample", resamp_num = 20000, measure = "dispersion"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/de_analysis.R
\name{QRscoreGenetest}
\alias{QRscoreGenetest}
\title{Perform Differential Expression Analysis using QRscore}
\usage{
QRscoreGenetest(
  expr_matrix,
  labels,
  size_factors = NULL,
  pairwise_test = FALSE,
  pairwise_logFC = FALSE,
  test_mean = TRUE,
  test_dispersion = FALSE,
  num_cores = 1,
  verbose = FALSE,
  rank = TRUE,
  seed = 1,
  ...
)
}
\arguments{
\item{expr_matrix}{A prefiltered raw count matrix (gene \eqn{\times}
sample).}

\item{labels}{A vector of labels corresponding to the samples.}

\item{size_factors}{A vector of size factors estimated from DESeq2}

\item{pairwise_test}{Logical, whether to perform pairwise test statistics
for more than two groups.}

\item{pairwise_logFC}{Logical, whether to calculate pairwise log fold
changes for mean and variance.}

\item{test_mean}{Logical, whether to test the mean.}

\item{test_dispersion}{Logical, whether to test the dispersion.}

\item{num_cores}{Integer, number of cores to use for parallel processing.}

\item{verbose}{Logical, whether to suppress all messages except warnings and
errors.}

\item{rank}{Logical. If TRUE, returns a ranked list of DEGs or DDGs sorted
by p-values.}

\item{seed}{Integer. Set seed in parallel computing.}

\item{...}{Additional arguments passed to the \code{QRscoreTest} function.}
}
\value{
A list with two data frames: \code{mean_test} and \code{var_test}.
}
\description{
This function performs differential expression analysis using the QRscore
method.
}
\examples{
data(example_dataset)
results <- QRscoreGenetest(
  expr_matrix = example_dataset$example_data1,
  labels = example_dataset$labels1,
  size_factors = example_dataset$size_factors1,
  pairwise_test = FALSE, pairwise_logFC = TRUE,
  test_mean = TRUE, test_dispersion = TRUE, num_cores = 2,
  approx = "asymptotic"
)
head(results$var_test)

results2 <- QRscoreGenetest(
  expr_matrix = example_dataset$example_data2,
  labels = example_dataset$labels2,
  size_factors = example_dataset$size_factors2,
  pairwise_test = TRUE, pairwise_logFC = TRUE,
  test_mean = TRUE, test_dispersion = FALSE, num_cores = 2,
  approx = "asymptotic"
)
head(results2$mean_test)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{computeweight_mean}
\alias{computeweight_mean}
\title{Compute weights for mean shift analysis}
\usage{
computeweight_mean(beta, mu, pi, n, k)
}
\arguments{
\item{beta}{Dispersion parameter of the negative binomial component. Must be
strictly positive.}

\item{mu}{Mean of the uninflated negative binomial distribution. Should be
non-negative.}

\item{pi}{Probability of zeros due to zero inflation.}

\item{n}{Sample size of \eqn{y}}

\item{k}{Sample size of \eqn{x}}
}
\value{
A list containing a weight vector (\verb{$weight}) and
estimated variance (\verb{$var}) useful for constructing test statistics.
}
\description{
Given the value of the estimated parameters for zero-inflated negative
binomial distribution (\eqn{\beta}, \eqn{\mu}, \eqn{\pi}),the sample sizes
\eqn{n} and \eqn{k} (by default \eqn{n\geqslant k}), this function computes
weights that target changes in the mean parameter of the zero-inflated
negative binomial model.
}
\details{
The function generates a vector of weights and an estimated variance that
are used to construct test statistics. The weight vector is computed by
considering how each potential count value from the combined distribution
contributes to the expected shift in mean, considering both inflated and
uninflated components.
}
\examples{

computeweight_mean(beta = 5, mu = 40, pi = 0.1, n = 100, k = 60)

}
